/* -*- C++ -*- */
/* This is the compilation configuration file for LyX. It was generated by 
   autoconf's configure. You might want to change some of the defaults if 
   something goes wrong during the compilation
   
   * This file is part of
   * ======================================================
   *
   *           LyX, the High Level Word Processor
   *
   *           Copyright (C) 1995 Matthias Ettrich
   *           Copyright (C) 1995-1998 The LyX Team
   *
   *======================================================*/

#ifndef _CONFIG_H
#define _CONFIG_H

@TOP@

/* Define to work around a bug with const handling in gcc 2.7.[012] */
#undef BROKEN_CONST

/* Define on SunOS 4 and SCO, were some functions are missing from the headers */
#undef BROKEN_HEADERS

/* Define if you have the STL from libg++ 2.7.x, where stack<> is not defined
   correctly */
#undef BROKEN_STL_STACK

/* Define if you want debugging turned on as default. */
#undef DEBUG_AS_DEFAULT

/* Define if you are building a development version of LyX */
#undef DEVEL_VERSION

/* Define to 1 if NLS is requested.  */
#undef ENABLE_NLS

/* Define to nothing if your compiler does not understand the
   `explicit' directive */
#undef explicit

/* Defined if you compiler supports `mutable'. */
#undef HAVE_MUTABLE

/* Defined if your compiler supports partial specialization. */
#undef HAVE_PARTIAL_SPECIALIZATION

/* define this to the location of forms.h to be used with #include,
  e.g. <forms.h> */
#undef FORMS_H_LOCATION

/* Define if your locale.h file contains LC_MESSAGES.  */
#undef HAVE_LC_MESSAGES

/* Define as 1 if you have catgets and don't want to use GNU gettext.  */
#undef HAVE_CATGETS

/* Define as 1 if you have gettext and don't want to use GNU gettext.  */
#undef HAVE_GETTEXT

/* Define as 1 if you have the stpcopy function */
#undef HAVE_STPCPY

/* Define if the bool type is known to your compiler */
#undef HAVE_bool

/* Define to the name of the distribution.  */
#undef PACKAGE

/* Define to use the LString class bundled with LyX */
#undef USE_INCLUDED_STRING

/* Define to the version of the distribution.  */
#undef VERSION

/* Define this if you want to see the #warning directives put here and
   there by the developpers to get attention */
#undef WITH_WARNINGS

/* define this to the location of xpm.h to be used with #include,
  e.g. <xpm.h> */
#undef XPM_H_LOCATION


@BOTTOM@ 

/************************************************************ 
 ** You should not need to change anything beyond this point */

/* even though -ansi might have been specified for gcc, we want all
  usual prototypes.  */
#ifdef __STRICT_ANSI__
/**/#undef __STRICT_ANSI__
#endif

#ifdef HAVE_FSTREAM
	#define FSTREAM_HEADER <fstream>
#else
	#ifdef HAVE_FSTREAM_H
		#define FSTREAM_HEADER <fstream.h>
	#else
		#define FSTREAM_HEADER bad_fstream_header
	#endif
#endif

#ifdef HAVE_IOSTREAM
#define IOSTREAM_HEADER <iostream>
#else
#ifdef HAVE_IOSTREAM_H
#define IOSTREAM_HEADER <iostream.h>
#else
#define bad_iostream_header
#endif
#endif

#ifdef HAVE_MEMSET
#define BZERO(a,b)      memset(a,0,b)
#else
#define BZERO(a,b)      bzero(a,b)
#endif

#ifndef HAVE_STRCHR
#define strchr(a,b)     index(a,b)
#endif

#ifndef HAVE_MEMMOVE
#define memmove(a, b, c)  bcopy(b, a, c)
#endif

#ifndef HAVE_STRERROR
#if defined (__cplusplus)
extern "C"
#endif
char * strerror(int n);
#endif

#ifndef HAVE_bool
#define bool int
#define true 1
#define false 0
#endif

#if SIZEOF_VOID_P == SIZEOF_INT
# define PTR_AS_INT(p) int(p)
#else
# define PTR_AS_INT(p) long(p)
#endif

#ifdef BROKEN_CONST
#include <string.h>
#include "broken_const.h"
#endif  

#ifdef const
#include <string.h>
#include "broken_const.h"
#endif  

#ifdef BROKEN_HEADERS
#include "broken_headers.h"
#endif

/* C++ always support the keyword `inline' */
#if defined inline && defined __cplusplus
/**/#undef inline
#endif

#ifdef __EMX__
#include "os2_defines.h"
#endif

#ifdef VMS
#include "vms_defines.h"
#endif

#endif /* _CONFIG_H */

