#!/bin/sh
# Generate the Makefiles and configure files
if ( aclocal --version ) </dev/null > /dev/null 2>&1; then
	echo "Building macros."
	aclocal; ( cd lib/reLyX; aclocal )
else
	echo "aclocal not found -- aborting"
	exit
fi

if ( automake --version ) </dev/null > /dev/null 2>&1; then
	echo "Building Makefiles"
	automake ; (cd lib/reLyX ; automake )
else
	echo "automake not found -- aborting"
	exit
fi

if ( autoheader --version ) </dev/null > /dev/null 2>&1; then
	echo "Building config header template"
	autoheader
else
	echo "autoheader not found -- aborting"
	exit
fi

if ( autoconf --version ) </dev/null > /dev/null 2>&1; then
	echo "Building configure"
	autoconf ; ( cd lib/reLyX ; autoconf )
	echo 'run "./configure ; make"'
else
	echo "autoconf not found -- aborting"
	exit
fi
