#include <iostream.h>
#include <string>
#include "lsignal.h"

// Global signals
Signal0 glob_sig0;
Signal1<int> glob_sig1;
Signal2<int,float> glob_sig2;
Signal3<int,float,int> glob_sig3;
Signal4<int,float,int,int> glob_sig4;
Signal5<int,float,int,int,int> glob_sig5;

class myclass : public virtual SignalBase {
  // this implements some functions that signal
  // system calls - Gtk_Object already does this derivation, so
// if you have Gtk_Object derived to this class already, no need to do 
// the derivation
//
// note, this is virtual derivation, but Gtk_Object is not derived 
// virtually!
public:
  Signal0 test_sig0;
  Signal1<string> test_sig1;
  Signal1<int> test_sig1_2;
	Signal2<int,float> test_sig2;
	Signal3<int,float,int> test_sig3;
	Signal4<int,float,int,int> test_sig4;
	Signal5<int,float,int,int,int> test_sig5;
	
	// after this, you can connect signals to this method
  void test0() { 
    cout << "test: " << endl;
  }
  void test0_cb(int cb) { 
    cout << "test: CB=" << cb << endl;
  }
  void test1_2(int a) { 
    // use a and f here
    cout <<"test1: " << a << endl;
  }
	void test1_2_cb(int a, int cb) { 
		// use a and f here
		cout <<"test1: " << a << " CB=" << cb << endl;
	}
	void test2(int a, float f) { 
		// use a and f here
		cout <<"test2: " << a << ' ' << f << endl;
	}
	void test2_cb(int a, float f, int cb) { 
		// use a and f here
		cout <<"test2: " << a << ' ' << f << " CB=" << cb <<endl;
	}
	void test3(int a, float f, int c) { 
		// use a and f here
		cout <<"test3: "
		     << a
		     << ' ' << f
		     << ' ' << c << endl;
	}
	void test3_cb(int a, float f, int c, int cb) { 
		// use a and f here
		cout <<"test3: "
		     << a
		     << ' ' << f
		     << ' ' << c
		     << " CB=" << cb << endl;
	}
	void test4(int a, float f, int c, int d) { 
		// use a and f here
		cout <<"test4: "
		     << a << ' '
		     << f << ' '
		     << c << ' '
		     << d << ' '
		     << endl;
	}
	void test4_cb(int a, float f, int c, int d, int cb) { 
		// use a and f here
		cout <<"test4: "
		     << a << ' '
		     << f << ' '
		     << c << ' '
		     << d << " CB="
		     << cb
		     << endl;
	}
	void test5(int a, float f, int c, int d, int e) { 
		// use a and f here
		cout <<"test5: "
		     << a << ' '
		     << f << ' '
		     << c << ' '
		     << d << ' '
		     << e << ' '
		     << endl;
	}
	void test5_cb(int a, float f, int c, int d, int e, int cb) { 
		// use a and f here
		cout <<"test5: "
		     << a << ' '
		     << f << ' '
		     << c << ' '
		     << d << ' '
		     << e << " CB="
		     << cb
		     << endl;
	}
};


void static_test_sig0()
{
	cout << "static_test_sig0\n";
}

void static_test_sig0_cb(int cb)
{
  cout << "static_test_sig0 CB=" << cb << endl;
}


 void static_test_sig1(string str)
 {
 	cout << "static_test_sig1: " << str << endl;
 }

void static_test_sig1_2(int i)
{
 	cout << "static_test_sig1_2: " << "int " << i << endl;
}

void static_test_sig1_2_cb(int i, int cb)
{
 	cout << "static_test_sig1_2: " << "int " << i << " CB=" << cb << endl;
}

 void static_test_sig2(int a, float b)
 {
	cout << "static_test_sig2: " << a << ' ' << b << endl;
 }
 void static_test_sig2_cb(int a, float b, int cb)
 {
 	cout << "static_test_sig2: " << a << ' ' << b << " CB=" << cb << endl;
 }

 void static_test_sig3(int a, float b, int c)
 {
  	cout << "static_test_sig3: "
  	     << a
  	     << ' ' << b
  	     << ' ' << c
  	     << endl;
 }
 void static_test_sig3_cb(int a, float b, int c, int cb)
 {
  	cout << "static_test_sig3: "
  	     << a
  	     << ' ' << b
  	     << ' ' << c
 	     << " CB=" << cb
  	     << endl;
 }

 void static_test_sig4(int a, float b, int c, int d)
 {
  	cout << "static_test_sig4: "
  	     << a
  	     << ' ' << b
  	     << ' ' << c
  	     << ' ' << d
  	     << endl;
 }
 void static_test_sig4_cb(int a, float b, int c, int d, int cb)
 {
  	cout << "static_test_sig4: "
  	     << a
  	     << ' ' << b
  	     << ' ' << c
  	     << ' ' << d
 	     << " CB=" << cb
  	     << endl;
 }

 void static_test_sig5(int a, float b, int c, int d, int e)
 {
  	cout << "static_test_sig5: "
  	     << a
  	     << ' ' << b
 	     << ' ' << c
  	     << ' ' << d
  	     << ' ' << e
  	     << endl;
 }
 void static_test_sig5_cb(int a, float b, int c, int d, int e, int cb)
 {
  	cout << "static_test_sig5: "
  	     << a
  	     << ' ' << b
  	     << ' ' << c
  	     << ' ' << d
  	     << ' ' << e
 	     << " CB=" << cb
  	     << endl;
 }

int main() {
  myclass w;
  myclass c;
  
  // we specify here the signal, receiving object and function inside 
  // receiving object
  
  // Connect to static function
  connect_to_function(w.test_sig0, static_test_sig0);
  connect_to_function(w.test_sig1, static_test_sig1);
  connect_to_function(w.test_sig1_2, static_test_sig1_2);
 	Connection cc = connect_to_function(w.test_sig2, static_test_sig2);
 	connect_to_function(w.test_sig3, static_test_sig3);
 	connect_to_function(w.test_sig4, static_test_sig4);
 	connect_to_function(w.test_sig5, static_test_sig5);

 	// Connect to static function with callback
  connect_to_function(w.test_sig0, static_test_sig0_cb, 1);
 	connect_to_function(w.test_sig1_2, static_test_sig1_2_cb, 2);
 	connect_to_function(w.test_sig2, static_test_sig2_cb, 3);
 	connect_to_function(w.test_sig3, static_test_sig3_cb, 4);
 	connect_to_function(w.test_sig4, static_test_sig4_cb, 5);
 	connect_to_function(w.test_sig5, static_test_sig5_cb, 6);

	// Connect to global static function
  connect_to_function(glob_sig0, static_test_sig0);
 	connect_to_function(glob_sig1, static_test_sig1_2);
 	connect_to_function(glob_sig2, static_test_sig2);
 	connect_to_function(glob_sig3, static_test_sig3);
 	connect_to_function(glob_sig4, static_test_sig4);
 	connect_to_function(glob_sig5, static_test_sig5);
	
	// Connect to global static function with callback
 	connect_to_function(glob_sig0, static_test_sig0_cb, 1);
  	connect_to_function(glob_sig1, static_test_sig1_2_cb, 2);
  	connect_to_function(glob_sig2, static_test_sig2_cb, 3);
  	connect_to_function(glob_sig3, static_test_sig3_cb, 4);
  	connect_to_function(glob_sig4, static_test_sig4_cb, 5);
  	connect_to_function(glob_sig5, static_test_sig5_cb, 6);
	
 	// connect to member function
 	connect_to_method(w.test_sig0, &c, &myclass::test0);
 	connect_to_method(w.test_sig1_2, &c, &myclass::test1_2);
 	connect_to_method(w.test_sig2, &c, &myclass::test2);
 	connect_to_method(w.test_sig3, &c, &myclass::test3);
 	connect_to_method(w.test_sig4, &c, &myclass::test4);
 	connect_to_method(w.test_sig5, &c, &myclass::test5);

 	// connect to member function with callback
  	connect_to_method(w.test_sig0, &c, &myclass::test0_cb, 1);
 	connect_to_method(w.test_sig1_2, &c, &myclass::test1_2_cb, 2);
  	connect_to_method(w.test_sig2, &c, &myclass::test2_cb, 3);
  	connect_to_method(w.test_sig3, &c, &myclass::test3_cb, 4);
  	connect_to_method(w.test_sig4, &c, &myclass::test4_cb, 5);
  	connect_to_method(w.test_sig5, &c, &myclass::test5_cb, 6);

 	// connect to member function
 	connect_to_method(glob_sig0, &c, &myclass::test0);
 	connect_to_method(glob_sig1, &c, &myclass::test1_2);
 	connect_to_method(glob_sig2, &c, &myclass::test2);
 	connect_to_method(glob_sig3, &c, &myclass::test3);
 	connect_to_method(glob_sig4, &c, &myclass::test4);
 	connect_to_method(glob_sig5, &c, &myclass::test5);

 	// connect to member function with callback
  	connect_to_method(glob_sig0, &c, &myclass::test0_cb, 1);
  	connect_to_method(glob_sig1, &c, &myclass::test1_2_cb, 2);
  	connect_to_method(glob_sig2, &c, &myclass::test2_cb, 3);
  	connect_to_method(glob_sig3, &c, &myclass::test3_cb, 4);
  	connect_to_method(glob_sig4, &c, &myclass::test4_cb, 5);
  	connect_to_method(glob_sig5, &c, &myclass::test5_cb, 6);

	// connect to signal...	
	connect_to_signal(glob_sig0, w.test_sig0);
	
 	// emit method signals
 	w.test_sig0();
 	w.test_sig1("Lars");
 	w.test_sig1_2(5);
 	w.test_sig2(3, 4.0);
 	w.test_sig3(3, 6.7, 1);
 	w.test_sig4(4, 7.6, 2, 4);
 	w.test_sig5(5, 3.14, 3, 6, 12);

	// emit global signals
	glob_sig0();
 	glob_sig1(5);
 	glob_sig2(3, 4.0);
 	glob_sig3(3, 6.7, 1);
 	glob_sig4(4, 7.6, 2, 4);
 	glob_sig5(5, 3.14, 3, 6, 12);

	cc.disconnect();

	w.test_sig2(7, 3.5);
	
	//Connection cc=connect(w.outputsignal, %c, myclass::fooimpl);
	
	//cc.disconnect(); // we can also disconnect signals at runtime when
	// needed - If Connection-object is copied, the old
	// one loses its ability to disconnect -- i.e. works like
	// auto_ptr.
}
