/* This file is part of
* ======================================================
* 
*           LyX, The Document Processor
*        
*           Copyright (C) 1995 Matthias Ettrich
*           Copyright (C) 1995-1998 The LyX Team.
*
*======================================================*/

#include <config.h>

#include <stdlib.h>
#include <unistd.h>

#ifdef __GNUG__
#pragma implementation
#endif

// Needed to support STLport on most old compilers
// Should not affect anything.  ARRae
#define __PUT_STATIC_DATA_MEMBERS_HERE

#include "libgui.h"
#include "textutils.h"
#include "commandtags.h"
#include "BufferView.h"
#include "bufferlist.h"
#include "LyXView.h"
#include "Popups.h"
#include "intl.h"
#include "trans_mgr.h"
#include "lyxfunc.h"
#include "minibuffer.h"
#include "lyxscreen.h"
#include "debug.h"
#include "lyx_gui_misc.h"
#include "lyxtext.h"
#include "lyx_cb.h"
#include "gettext.h"
#include "insetspecialchar.h"
#include "insetinfo.h"
#include "insettoc.h"
#include "insetlof.h"
#include "insetlot.h"
#include "insetloa.h"
#include "formula.h"
#include "lyxlib.h"
#include "filetools.h"
#include "LAssert.h"
#include "textclasslist.h"
#include "menus.h"
#include "insettabular.h"
#include "workarea.h"

// 	$Id: BufferView.C,v 1.37 1998/10/22 16:56:01 larsbj Exp $	

#if !defined(lint) && !defined(WITH_WARNINGS)
static char vcid[] = "$Id: BufferView.C,v 1.37 1998/10/22 16:56:01 larsbj Exp $";
#endif /* lint */

extern BufferList bufferlist;

extern bool input_prohibited;
bool selection_possible;
extern char ascii_type;

// This is both GUI and LyXFont dependent. Don't know where to put it. (Asger)
// Well, it's mostly GUI dependent, so I guess it will stay here. (Asger)
#warning rewrite to make it gui indep
// This func is actually quite nasty. It relys on information beeing stored
// in the gui, that should _never_ be done. Should not be terribly hard
// to fix. (Lgb)
// since this is the only file where this is called I put it here,
// it it needs to be fixed pretty soon. (Lgb)
#warning Fix! Fix! Fix!
#include "layout_forms.h"
extern FD_form_character *fd_form_character;
static LyXFont UserFreeFont()
{
	LyXFont font(LyXFont::ALL_IGNORE);
	int pos;

	pos = fl_get_choice(fd_form_character->choice_family);
	switch(pos) {
	case 1: font.setFamily(LyXFont::IGNORE_FAMILY); break;
	case 2: font.setFamily(LyXFont::ROMAN_FAMILY); break;
	case 3: font.setFamily(LyXFont::SANS_FAMILY); break;
	case 4: font.setFamily(LyXFont::TYPEWRITER_FAMILY); break;
	case 5: font.setFamily(LyXFont::INHERIT_FAMILY); break;
	}

	pos = fl_get_choice(fd_form_character->choice_series);
	switch(pos) {
	case 1: font.setSeries(LyXFont::IGNORE_SERIES); break;
	case 2: font.setSeries(LyXFont::MEDIUM_SERIES); break;
	case 3: font.setSeries(LyXFont::BOLD_SERIES); break;
	case 4: font.setSeries(LyXFont::INHERIT_SERIES); break;
	}

	pos = fl_get_choice(fd_form_character->choice_shape);
	switch(pos) {
	case 1: font.setShape(LyXFont::IGNORE_SHAPE); break;
	case 2: font.setShape(LyXFont::UP_SHAPE); break;
	case 3: font.setShape(LyXFont::ITALIC_SHAPE); break;
	case 4: font.setShape(LyXFont::SLANTED_SHAPE); break;
	case 5: font.setShape(LyXFont::SMALLCAPS_SHAPE); break;
	case 6: font.setShape(LyXFont::INHERIT_SHAPE); break;
	}

	pos = fl_get_choice(fd_form_character->choice_size);
	switch(pos) {
	case 1: font.setSize(LyXFont::IGNORE_SIZE); break;
	case 2: font.setSize(LyXFont::SIZE_TINY); break;
	case 3: font.setSize(LyXFont::SIZE_SCRIPT); break;
	case 4: font.setSize(LyXFont::SIZE_FOOTNOTE); break;
	case 5: font.setSize(LyXFont::SIZE_SMALL); break;
	case 6: font.setSize(LyXFont::SIZE_NORMAL); break;
	case 7: font.setSize(LyXFont::SIZE_LARGE); break;
	case 8: font.setSize(LyXFont::SIZE_LARGER); break;
	case 9: font.setSize(LyXFont::SIZE_LARGEST); break;
	case 10: font.setSize(LyXFont::SIZE_HUGE); break;
	case 11: font.setSize(LyXFont::SIZE_HUGER); break;
	case 12: font.setSize(LyXFont::INCREASE_SIZE); break;
	case 13: font.setSize(LyXFont::DECREASE_SIZE); break;
	case 14: font.setSize(LyXFont::INHERIT_SIZE); break;
	}

	pos = fl_get_choice(fd_form_character->choice_bar);
	switch(pos) {
	case 1: font.setEmph(LyXFont::IGNORE);
		font.setUnderbar(LyXFont::IGNORE);
		font.setNoun(LyXFont::IGNORE);
		font.setLatex(LyXFont::IGNORE);
		break;
	case 2: font.setEmph(LyXFont::TOGGLE); break;
	case 3: font.setUnderbar(LyXFont::TOGGLE); break;
	case 4: font.setNoun(LyXFont::TOGGLE); break;
	case 5: font.setLatex(LyXFont::TOGGLE); break;
	case 6: font.setEmph(LyXFont::INHERIT);
		font.setUnderbar(LyXFont::INHERIT);
		font.setNoun(LyXFont::INHERIT);
		font.setLatex(LyXFont::INHERIT);
		break;
	}

	pos = fl_get_choice(fd_form_character->choice_color);
	switch(pos) {
	case 1: font.setColor(LColor::ignore); break;
	case 2: font.setColor(LColor::none); break;
	case 3: font.setColor(LColor::black); break;
	case 4: font.setColor(LColor::white); break;
	case 5: font.setColor(LColor::red); break;
	case 6: font.setColor(LColor::green); break;
	case 7: font.setColor(LColor::blue); break;
	case 8: font.setColor(LColor::cyan); break;
	case 9: font.setColor(LColor::magenta); break;
	case 10: font.setColor(LColor::yellow); break;
	case 11: font.setColor(LColor::inherit); break;
	}

	return font; 
}


bool BufferView::readyForKeypress() const {
	return workarea->hasFocus() && workarea->active();
}


int BufferView::paperWidth() const
{
	return workarea->workWidth();
}


int BufferView::width() const
{
	return workarea->width();
}


int BufferView::height() const
{
	return workarea->height();
}


int BufferView::xpos() const
{
	return workarea->xpos();
}


int BufferView::ypos() const
{
	return workarea->ypos();
}

void BufferView::toggleSelection(bool b = true)
{
	screen_->toggleSelection(b);
}

void BufferView::hideCursor()
{
	if (screen_) screen_->hideCursor();
}


void BufferView::showCursor()
{
	screen_->showCursor();
}


BufferView::BufferView(LyXView *o, int xpos, int ypos,
		       int width, int height)
	: owner_(o)
{
	buffer_ = 0;

	text = 0;
	screen_ = 0;
	current_scrollbar_value = 0;
	inset_slept = false;
	the_locking_inset = 0;
	
	// Create the workarea
	workarea = new WorkArea(xpos, ypos, width, height);
	
	connect_to_method(workarea->up, this, &BufferView::UpCB);
	connect_to_method(workarea->down, this, &BufferView::DownCB);
	connect_to_method(workarea->scroll, this, &BufferView::ScrollCB);
	connect_to_method(workarea->expose, this, &BufferView::workAreaExpose);
	connect_to_method(workarea->buttonPress, this, &BufferView::WorkAreaButtonPress);
	connect_to_method(workarea->buttonRelease, this, &BufferView::WorkAreaButtonRelease);
	connect_to_method(workarea->motion, this, &BufferView::WorkAreaMotionNotify);
#warning these need implementation (badly)
	// The old code is commented out some pages below, so it is just some
	// work to do this.
	
	//connect_to_method(workarea->focus, this, &BufferView::);
	//connect_to_method(workarea->unfocus, this, &BufferView::);
	//connect_to_method(workarea->enter, this, &BufferView::);
	//connect_to_method(workarea->leave, this, &BufferView::);
	//connect_to_method(workarea->doubleclick, this, &BufferView::);
	//connect_to_method(workarea->trippleclick, this, &BufferView::);
	connect_to_method(workarea->selection, this, &BufferView::WorkAreaSelectionNotify);
	
	// Activate the timer for the cursor ++
	connect_to_method(timer_update.bell, this, &BufferView::UpdateTimerCB);
	connect_to_method(timer_cursor.bell, this, &BufferView::CursorToggleCB);
	timer_cursor.set(0.4);
	workarea->setFocus();

	work_area_focus = true;
	lyx_focus = false;
	//backstack = new BackStack(16);
	InsetUpdateList = 0;
}


BufferView::~BufferView()
{
	//delete [] backstack;
	if (text != 0)
		delete text;
}   


void BufferView::setBuffer(Buffer *b)
{
	lyxerr[Debug::INFO] << "Setting buffer in BufferView\n";
	if (buffer_) {
		InsetSleep();
		buffer_->delUser(this);
	}

	// this is a bit unfortunate since we now
	// need to do a complete rebreak each time we switch buffer...
	text = 0;

	// Set current buffer
	buffer_ = b;

	if (bufferlist.getState() == BufferList::CLOSING) return;

	// Nuke old image
	if (screen_) {
		delete screen_;
		screen_ = 0;
	}

	// If we are closing the buffer, use the first buffer as current
	if (!buffer_ && !bufferlist.empty()) {
		buffer_ = bufferlist.first();
	}

	if (buffer_) {
		lyxerr[Debug::INFO] << "  Buffer addr: "
				    << (void*)buffer_ << '\n';
		buffer_->addUser(this);
		owner_->getMenus()->showMenus();
		// If we don't have a text object for this, we make one
		if (text == 0)
			resizeCurrentBuffer();
		else {
			updateScreen();
			updateScrollbar();
		}
		screen_->first = screen_->TopCursorVisible();
		redraw();
		owner_->getPopups().updateBufferDependent();
		InsetWakeup();
	} else {
		lyxerr[Debug::INFO] << "  No Buffer!\n";
		owner_->getMenus()->hideMenus();
		updateScrollbar();
		workarea->redraw();
	}
	// should update layoutchoice even if we don't have a buffer.
	owner_->updateLayoutChoice();
	owner_->getMiniBuffer()->Init();
	owner_->updateWindowTitle();
}


void BufferView::setFocus() const {
	workarea->setFocus();
}


void BufferView::updateScreen()
{
	// Regenerated the screen.
	if (screen_) delete screen_;
	screen_ = new LyXScreen(this, workarea->getWin(),
				workarea->getPixmap(),
				workarea->workWidth(),
				workarea->height(),
				workarea->xpos(),
				workarea->ypos(),
				text);
}


void BufferView::resize(int xpos, int ypos,  int width, int height)
{
	workarea->resize(xpos, ypos, width, height);
	update(ResetSelection|FitCursor);
	redraw();
}


void BufferView::resize()
{
	// This will resize the buffer. (Asger)
	if (buffer_)
		resizeCurrentBuffer();
}


void BufferView::redraw()
{
	lyxerr[Debug::INFO] << "BufferView::redraw()\n";
	workarea->redraw();
}


void BufferView::fitCursor()
{
	if (screen_ && screen_->FitCursor())
	    updateScrollbar();
}


void BufferView::update()
{
	if (screen_) screen_->Update();
}


void BufferView::updateScrollbar()
{
	/* If the text is smaller than the working area, the scrollbar
	 * maximum must be the working area height. No scrolling will 
	 * be possible */

	if (!buffer_) {
		workarea->setScrollbar(0, 1.0);
		return;
	}
	
	static long max2 = 0;
	static long height2 = 0;

	long cbth = 0;
	long cbsf = 0;

	if (text)
		cbth = text->height;
	if (screen_)
		cbsf = screen_->first;

	// check if anything has changed.
	if (max2 == cbth &&
	    height2 == workarea->height() &&
	    current_scrollbar_value == cbsf)
		return;	      // no
	
	max2 = cbth;
	height2 = workarea->height();
	current_scrollbar_value = cbsf;

	
	if (cbth <= height2) { // text is smaller than screen
		workarea->setScrollbar(0, 1.0); // right?
		return;
	}
	
	long maximum_height = workarea->height() * 3/4 + cbth;
	long value = cbsf;

	// Set the scrollbar.
	double hfloat = workarea->height();
	double maxfloat = maximum_height;

	float slider_size = 0.0;
	int slider_value = value;

	workarea->setScrollbarBounds(0, text->height - workarea->height()); //  maximum_height - work_area->h
	double lineh = text->DefaultHeight();
	workarea->setScrollbarIncrements(lineh);
	if (maxfloat>0){
		if ((hfloat/maxfloat) * float(height2) < 3)
			slider_size = 3.0/float(height2);
		else
			slider_size = hfloat / maxfloat;
	} else
		slider_size = hfloat;
	
	workarea->setScrollbar(slider_value, slider_size / workarea->height());
}


void BufferView::redoCurrentBuffer()
{
	lyxerr[Debug::INFO] << "BufferView::redoCurrentBuffer\n";
	if (buffer_ && text) {
		resize();
		owner_->updateLayoutChoice();
	}
}


int BufferView::resizeCurrentBuffer()
{
	lyxerr[Debug::INFO] << "resizeCurrentBuffer\n";

	LyXParagraph *par = 0;
	LyXParagraph *selstartpar = 0;
	LyXParagraph *selendpar = 0;
	int pos = 0;
	int selstartpos = 0;
	int selendpos = 0;
	int selection = 0;
	int mark_set = 0;

	ProhibitInput();

	owner_->getMiniBuffer()->Set(_("Formatting document..."));   

	if (text) {
		par = text->cursor.par;
		pos = text->cursor.pos;
		selstartpar = text->sel_start_cursor.par;
		selstartpos = text->sel_start_cursor.pos;
		selendpar = text->sel_end_cursor.par;
		selendpos = text->sel_end_cursor.pos;
		selection = text->selection;
		mark_set = text->mark_set;
		delete text;
	}
	text = new LyXText(workarea->workWidth(), this);

	updateScreen();
   
	if (par) {
		text->selection = true;
		/* at this point just
		 * to avoid the Delete-
		 * Empty-Paragraph
		 * Mechanism when
		 * setting the cursor */
		text->mark_set = mark_set;
		if (selection) {
			text->SetCursor(selstartpar, selstartpos);
			text->sel_cursor = text->cursor;
			text->SetCursor(selendpar, selendpos);
			text->SetSelection();
			text->SetCursor(par, pos);
		} else {
			text->SetCursor(par, pos);
			text->sel_cursor = text->cursor;
			text->selection = false;
		}
	}
	screen_->first = screen_->TopCursorVisible(); /* this will scroll the
						     * screen such that the
						     * cursor becomes
						     * visible */ 
	updateScrollbar();
	redraw();
	owner_->getMiniBuffer()->Init();
	AllowInput();

	return 0;
}


bool BufferView::gotoLabel(const string &label)
{
	LyXCursor tmpcur = buffer_->getLabelCursor(label);
	if (tmpcur.par == 0) return false;
	beforeChange();
	text->SetCursor(tmpcur.par, tmpcur.pos);
	text->sel_cursor = text->cursor;
	update(ResetSelection|FitCursor);
	return true;
}


void BufferView::gotoError()
{
	if (!screen_)
		return;
   
	screen_->hideCursor();
	beforeChange();
	update(ResetSelection|FitCursor);
	LyXCursor tmp;
   
	if (!text->GotoNextError()) {
		if (text->cursor.pos 
		    || text->cursor.par !=
		    text->FirstParagraph()) {
			tmp = text->cursor;
			text->cursor.par =
				text->FirstParagraph();
			text->cursor.pos = 0;
			if (!text->GotoNextError()) {
				text->cursor = tmp;
				owner_->getMiniBuffer()->Set(_("No more errors"));
				LyXBell();
			}
		} else {
			owner_->getMiniBuffer()->Set(_("No more errors"));
			LyXBell();
		}
	}
	update(ResetSelection|FitCursor);
	text->sel_cursor =
		text->cursor;
}


void BufferView::gotoNote()
{
	if (!screen_) return;
	
	screen_->hideCursor();
	beforeChange();
	update(ResetSelection|FitCursor);
	LyXCursor tmp;
	
	if (!text->GotoNextNote()) {
		if (text->cursor.pos 
		    || text->cursor.par !=
		    text->FirstParagraph()) {
			tmp = text->cursor;
			text->cursor.par =
				text->FirstParagraph();
			text->cursor.pos = 0;
			if (!text->GotoNextNote()) {
				text->cursor = tmp;
				owner_->getMiniBuffer()->Set(_("No more notes"));
				LyXBell();
			}
		} else {
			owner_->getMiniBuffer()->Set(_("No more notes"));
			LyXBell();
		}
	}
	update(ResetSelection|FitCursor);
	text->sel_cursor = text->cursor;
}


// Slot for timer_update
void BufferView::UpdateTimerCB()
{
	if (!available()) return;
	if (!screen_) return;

	screen_->hideCursor();
	update(BufferView::ResetSelection|BufferView::FitCursor);
}


// Slot for scrollbar up button
void BufferView::UpCB(long time, int button)
{
	if (buffer_ == 0) return;
	
	switch (button) {
	case 3:
		ScrollUpOnePage(); break;
	case 2:
		ScrollDownOnePage(); break;
	default:
		ScrollUp(time); break;
	}
}


// Slot for scrollbar slider
void BufferView::ScrollCB(double value)
{
	extern bool cursor_follows_scrollbar;
	
	if (buffer_ == 0) return;

	current_scrollbar_value = long(value);
	if (current_scrollbar_value < 0)
		current_scrollbar_value = 0;
   
	if (!screen_)
		return;

	screen_->Draw(current_scrollbar_value);

	if (cursor_follows_scrollbar) {
		LyXText * vbt = text;
		int height = vbt->DefaultHeight();
		
		if (vbt->cursor.y < screen_->first + height) {
			vbt->SetCursorFromCoordinates(0,
						      screen_->first +
						      height);
		}
		else if (vbt->cursor.y >
			 screen_->first + workarea->height() - height) {
			vbt->SetCursorFromCoordinates(0,
						      screen_->first +
						      workarea->height()  -
						      height);
		}
	}
}


// Slot for scrollbar down button
void BufferView::DownCB(long time, int button)
{
	if (buffer_ == 0) return;
	switch (button) {
	case 2:
		ScrollUpOnePage(); break;
	case 3:
		ScrollDownOnePage(); break;
	default:
		ScrollDown(time); break;
	}
}


int BufferView::ScrollUp(long time)
{
	if (buffer_ == 0) return 0;
	if (!screen_)
		return 0;
   
	double value = workarea->getScrollbarValue();
   
	if (value == 0)
		return 0;
   
	float add_value =  (text->DefaultHeight()
			    + float(time) * float(time) * 0.125);
   
	if (add_value > workarea->height())
		add_value = float(workarea->height() -
				     text->DefaultHeight());
   
	value -= add_value;

	if (value < 0)
		value = 0;

	workarea->setScrollbarValue(value);
   
	ScrollCB(value); 
	return 0;
}


int BufferView::ScrollDown(long time)
{
	if (buffer_ == 0) return 0;
	if (!screen_)	return 0;
   
	double value = workarea->getScrollbarValue();
	double min, max;

	pair<double, double> p = workarea->getScrollbarBounds();
	min = p.first;
	max = p.second;
	
	if (value == max)
		return 0;
   
	float add_value =  (text->DefaultHeight()
			    + float(time) * float(time) * 0.125);
   
	if (add_value > workarea->height())
		add_value = float(workarea->height() -
				     text->DefaultHeight());
   
	value += add_value;
   
	if (value > max)
		value = max;

	workarea->setScrollbarValue(value);
   
	ScrollCB(value); 
	return 0;
}


void BufferView::ScrollUpOnePage()
{
	if (buffer_ == 0) return;
	if (!screen_)
		return;
   
	long y = screen_->first;

	if (!y) return;
   
	Row* row = text->GetRowNearY(y);
	y = y - workarea->height() + row->height;

	workarea->setScrollbarValue(y);
   
	ScrollCB(y); 
}


void BufferView::ScrollDownOnePage()
{
	if (buffer_ == 0) return;
	if (!screen_)	return;
   
	long y = screen_->first;
   
	if (y > text->height - workarea->height())
		return;
   
	y += workarea->height();
	text->GetRowNearY(y);

	workarea->setScrollbarValue(y);
   
	ScrollCB(y); 
}


//  int BufferView::work_area_handler(FL_OBJECT * ob, int event,
//  				  FL_Coord, FL_Coord ,
//  				  int /*key*/, void *xev)
//  {
//  	static int x_old = -1;
//  	static int y_old = -1;
//  	static long scrollbar_value_old = -1;
	
//  	XEvent* ev = (XEvent*) xev;
//  	BufferView *view = (BufferView*) ob->u_vdata;

//  	// If we don't have a view yet; return
//  	if (!view || quitting) return 0;

//  	switch (event){   
//  	case FL_DRAW:
//  		view->workAreaExpose(); 
//  		break;
//  	case FL_PUSH:
//  		view->WorkAreaButtonPress(ob, 0,0,0,ev,0);
//  		break; 
//  	case FL_RELEASE:
//  		view->WorkAreaButtonRelease(ob, 0,0,0,ev,0);
//  		break;
//  	case FL_MOUSE:
//  		if (ev->xmotion.x != x_old || 
//  		    ev->xmotion.y != y_old ||
//  		    view->current_scrollbar_value != scrollbar_value_old){
//  			x_old = ev->xmotion.x;
//  			y_old = ev->xmotion.y;
//  			scrollbar_value_old = view->current_scrollbar_value;
//  			view->WorkAreaMotionNotify(ob, 0,0,0,ev,0);
//  		}		break;
//  	// Done by the raw callback:
//  	//  case FL_KEYBOARD: WorkAreaKeyPress(ob, 0,0,0,ev,0); break;
//  	case FL_FOCUS:
//  		if (!view->owner_->getMiniBuffer()->shows_no_match)
//  			view->owner_->getMiniBuffer()->Init();
//  		view->owner_->getMiniBuffer()->shows_no_match = false;
//  		view->work_area_focus = true;
//  		fl_set_timer(view->timer_cursor, 0.4);
//  		break;
//  	case FL_UNFOCUS:
//  		view->owner_->getMiniBuffer()->ExecCommand();
//  		view->work_area_focus = false;
//  		break;
//  	case FL_ENTER:
//  		setXtermCursor(fl_display, view->owner_->getForm()->window);
//  		// reset the timer
//  		view->lyx_focus = true;
//  		fl_set_timer(view->timer_cursor, 0.4);
//  		break;
//  	case FL_LEAVE: 
//  		if (!input_prohibited)
//  			XUndefineCursor(fl_display,
//  					view->owner_->getForm()->window);
//  		view->lyx_focus = false; // this is not an ablsolute truth
//  		// but if it is not true, it will be changed within a blink
//  		// of an eye. ... Not good enough... use regulare timeperiod
//  		//fl_set_timer(view->timer_cursor, 0.01); // 0.1 sec blink
//  		fl_set_timer(view->timer_cursor, 0.4); // 0.4 sec blink
//  		break;
//  	case FL_DBLCLICK: 
//  		// select a word 
//  		if (view->buffer_ &&
//  		    !view->buffer_->the_locking_inset) {
//  			if (view->screen_ &&
//  			    ev->xbutton.button == 1) {
//  				view->screen_->hideCursor();
//  				view->screen_->
//  					toggleSelection(); 
//  				view->text->SelectWord();
//  				view->screen_->
//  					toggleSelection(false);
//  				view->update(ResetSelection|FitCursor); /* this will fit the cursor on the screen
//  					    * if necessary */ 
//  			}
//  		}
//  		break;
//  	case FL_TRPLCLICK:
//  		// select a line
//  		if (view->buffer_ &&
//  		    view->screen_ && ev->xbutton.button == 1){
//  			view->screen_->hideCursor(); 
//  			view->screen_->toggleSelection(); 
//  			view->text->CursorHome();
//  			view->text->sel_cursor =
//  				view->text->cursor;
//  			view->text->CursorEnd();
//  			view->text->SetSelection();
//  			view->screen_->toggleSelection(false); 
//  			view->update(ResetSelection|FitCursor); /* this will fit the cursor on the screen
//  				    * if necessary */ 
//  		}
//  		break;
//  	case FL_OTHER:
//  		view->WorkAreaSelectionNotify(ob,
//  					      view->owner_->getForm()->window,
//  					      0,0,ev,0); 
//  		break;
//  	}
  
//  	return 1;
//  }


void BufferView::WorkAreaMotionNotify(int x, int y, unsigned int state)
{
	if (buffer_ == 0 || !screen_) return ;
   
	// Check for inset locking.
	if (the_locking_inset){
		LyXCursor cursor = text->cursor;
		the_locking_inset->
			InsetMotionNotify(x - cursor.x,
					  y - cursor.y,
					  state);
		return ;
	}
   
	// Only use motion with button 1.
	if (!state & Button1MotionMask)
		return ; 
    
   
	/* the selection possible is needed, that only motion events are 
	 * used, where the bottom press event was on the drawing area too */
	if (selection_possible) {
      
		screen_->hideCursor();

		text->SetCursorFromCoordinates(x,
					       y +
					       screen_->first);

		if (!text->selection)
			update(RebreakOnly);       /* maybe an empty line was deleted  */

		text->SetSelection();
		screen_->ToggleToggle();
		fitCursor();
		screen_->showCursor();
	} 
	return ;
}


// shis should be replaced by functions like:
// fromclipboard
// toclipboard

// now we have fromclipboard no we only need to make toclipboard
static string fromClipboard(Window win, XEvent *event)
{
	string strret;
	if (event->xselection.type == XA_STRING
	    && event->xselection.property) {
		Atom tmpatom;
		unsigned long ul1;
		unsigned long ul2;
		unsigned char* uc = 0;
		int tmpint;
		if (XGetWindowProperty(
			event->xselection.display,  // display
			win,                        // w
			event->xselection.property, // property
			0,                          // long_offset	
			0,                          // logn_length	
			False,                      // delete	
			XA_STRING,                  // req_type	
			&tmpatom,                   // actual_type_return
			&tmpint,                    // actual_format_return
			&ul1,
			&ul2,
			&uc                         // prop_return	
			) != Success) {
			return strret;
		}
		if (uc) {
			free(uc);
			uc = 0;
		}
		if (XGetWindowProperty(
			event->xselection.display,             // display
			win,                        // w
			event->xselection.property, // property
			0,                          // long_offset
			ul2/4+1,                    // long_length
			True,                       // delete
			XA_STRING,                  // req_type
			&tmpatom,                   // actual_type_return
			&tmpint,                    // actual_format_return
			&ul1,                       // nitems_return
			&ul2,                       // bytes_after_return
			&uc                         // prop_return */
			) != Success) {
			return strret;
		}
		if (uc) {
			strret = (char*)uc;
			free(uc);
			uc = 0;
		}
	}
	return strret;
}


void BufferView::WorkAreaSelectionNotify(Window win, XEvent *event)
{
	if (buffer_ == 0) return;

	screen_->hideCursor();
	beforeChange();
	string clb = fromClipboard(win, event);
	if (!clb.empty()) {
		if (!ascii_type)
			text->InsertStringA(clb);
		else
			text->InsertStringB(clb);
		
		update(ResetSelection|FitCursor|BufferChange);
	}
}


extern int bibitemMaxWidth(Buffer const *, Painter &, const class LyXFont &);

// Single-click on work area
void BufferView::WorkAreaButtonPress(int xpos, int ypos, unsigned int button)
{
	lyxerr << "We have a button press in workarea.\n";

	if (buffer_ == 0 || !screen_) return;

	
	if (the_locking_inset){
		/* check whether the inset was hit. If not reset mode,
		   otherwise give the event to the inset */
		if (checkInsetHit(xpos, ypos)){ 
		    the_locking_inset->
				InsetButtonPress(xpos, ypos, button);
			return;
		} else {
			unlockInset(the_locking_inset);
		}
	}
   
	selection_possible = true;
	screen_->hideCursor();
        
	int screen_first = screen_->first;

	// Middle button press pastes if we have a selection
	bool paste_internally = false;
	if (button == 2 && !the_locking_inset
	    && text->selection) {
		owner_->getLyXFunc().Dispatch(LFUN_COPY);
		paste_internally = true;
	}

	/* clear the selection */ 
	screen_->toggleSelection();
	text->ClearSelection();
	text->FullRebreak();
	screen_->Update();
	updateScrollbar();

	// Right click on a footnote flag opens float menu
	if (button == 3 &&
            text->cursor.par->footnoteflag == LyXParagraph::OPEN_FOOTNOTE) {
		selection_possible = false;
		lyxerr << "LyX: Sorry not implemented yet.\n";
		return;
	}

	if (button == 3) {
		selection_possible = false;
		return;
	}

   
	text->SetCursorFromCoordinates(xpos, ypos + screen_first);
	text->FinishUndo();
	text->sel_cursor = text->cursor;
	text->cursor.x_fix = text->cursor.x;
   
	/* Single left click */
	if (button == 1) {
		// Did we hit an inset?
		if (checkInsetHit(xpos, ypos)){
			if (text->cursor.par->
			    GetInset(text->cursor.pos)->
			    Editable() == 2) {
				// Highly editable inset, like math
				selection_possible = false;
				owner_->updateLayoutChoice();
				owner_->getMiniBuffer()->
					Set(text->cursor.par->
					    GetInset(text->cursor.pos)->
					    EditMessage());
				text->cursor.par->
					GetInset(text->cursor.pos)->
					Edit(xpos, ypos, button, this);
				return;
			} else {
				// Other inset like error, notes
				// and figures
				selection_possible = false;
#ifdef WITH_WARNINGS
#warning fix this proper in 0.13
#endif
				// Following a ref shouldn't issue
				// a push on the undo-stack
				// anylonger, now that we have
				// keybindings for following
				// references and returning from
				// references.  IMHO though, it
				// should be the inset's own business
				// to push or not push on the undo
				// stack. They don't *have* to
				// alter the document...
				// (Joacim)
				// ...or maybe the SetCursorParUndo()
				// below isn't necessary at all anylonger?
				if (!text->cursor.par->
				    GetInset(text->cursor.pos)->
				    LyxCode() == Inset::REF_CODE)
					text->
						SetCursorParUndo();
				
				owner_->getMiniBuffer()->
					Set(text->cursor.par->
					    GetInset(text->
						     cursor.pos)->
					    EditMessage());
				text->cursor.par->
					GetInset(text->cursor.pos)->
					Edit(xpos, ypos, button, this);
				return;
			}
		}

		// check whether we want to open a float
		if (text && 
		    text->cursor.pos <
		    text->cursor.par->Last()) {
			char c = text->cursor.par->
				GetChar(text->cursor.pos);
			if (IsFloatChar(c)) {
				toggleFloat();
				selection_possible = false;
				return;
			}
		}

		// do we want to close a float (click on the float-label)
		if (text->cursor.row->par->footnoteflag ==
		    LyXParagraph::OPEN_FOOTNOTE
		    && text->cursor.pos == 0
		    && text->cursor.row->previous &&
		    text->cursor.row->previous->par->
		    footnoteflag != LyXParagraph::OPEN_FOOTNOTE) {
			LyXFont font (LyXFont::ALL_SANE);
			font.setSize(LyXFont::SIZE_SMALL);

			int box_x = 20; // LYX_PAPER_MARGIN;
			box_x += font.textWidth("Mwide-figM", 10);
       
			if (xpos < box_x &&
			    ypos + screen_first > text->cursor.y -
			    text->cursor.row->baseline &&
			    ypos + screen_first < (text->cursor.y -
						   text->cursor.row->baseline
						   + font.maxAscent()*1.2 +
						   font.maxDescent()*1.2)) {
				toggleFloat();
				selection_possible = false;
				return;
			}
		}
	    
	        // Maybe we want to edit a bibitem ale970302
	        if (text->cursor.par->bibkey &&
		    xpos < 20+bibitemMaxWidth(buffer_,
					      workarea->getPainter(),
					      textclasslist.textClass(buffer_->
					      params.textclass)->defaultfont)) {
			text->cursor.par->bibkey->Edit(0, 0, button, this);
		}
	}
   
	owner_->updateLayoutChoice();
	if (screen_->FitCursor()){
		updateScrollbar();
		selection_possible = false;
	}

	// insert primary selection with middle mouse
	// if there is a local selection in the current buffer, insert this
	if (button == 2 && !the_locking_inset){
		if (paste_internally)
			owner_->getLyXFunc().Dispatch(LFUN_PASTE);
		else
			owner_->getLyXFunc().Dispatch(LFUN_PASTESELECTION,
						      "paragraph");
		selection_possible = false;
	}
	return;
}

extern bool Lgb_bug_find_hack;

void BufferView::workAreaExpose()
{
	if (!Lgb_bug_find_hack)
		lyxerr << "workAreaExpose not called from "
			"workarea::workhandler\n";
	
	if (!workarea || !workarea->visible()) return;

	static int work_area_width = -1;
	static int work_area_height = -1;

	bool widthChange = workarea->workWidth() != work_area_width;
	bool heightChange = workarea->height() != work_area_height;

	// update from work area
	work_area_width = workarea->workWidth();
	work_area_height = workarea->height();
		
	if (buffer_ != 0) {
		if (widthChange) {
			lyxerr[Debug::INFO] << "Width of workarea changed.\n";
			// All buffers need a resize
			bufferlist.resize();
		} else if (heightChange) {
			lyxerr[Debug::INFO] << "Height of workarea changed.\n";
			// Rebuild image of current screen
			updateScreen();
			// fitCursor() ensures we don't jump back
			// to the start of the document on vertical
			// resize
			fitCursor();

			// The main window size has changed, repaint most stuff
			redraw();
			// ...including the minibuffer
			owner_->getMiniBuffer()->Init();

		} else if (screen_) screen_->Redraw();
	} else {
		// Grey box when we don't have a buffer
		workarea->greyOut();
	}

	// always make sure that the scrollbar is sane.
	updateScrollbar();
	owner_->updateLayoutChoice();
	return;
}


// Slot for cursor timer
void BufferView::CursorToggleCB()
{
	/* quite a nice place for asyncron Inset updating, isn't it? */
	// actually no! This is run even if no buffer exist... so (Lgb)
	if (!buffer_) {
		goto set_timer_and_return;
	}
	
	if (InsetUpdateList) 
		updateInsetUpdateList();

	if (!screen_){
		goto set_timer_and_return;
	}

	if (lyx_focus && work_area_focus) {
		if (!the_locking_inset){
			screen_->CursorToggle();
		} else {
			the_locking_inset->
				ToggleInsetCursor();
		}
		goto set_timer_and_return;
	} else {
		// Make sure that the cursor is visible.
		if (!the_locking_inset){
			screen_->showCursor();
		} else {
			if (!the_locking_inset->isCursorVisible())
				the_locking_inset->
					ToggleInsetCursor();
		}

		// This is only run when work_area_focus or lyx_focus is false.
		Window tmpwin;
		int tmp;
		XGetInputFocus(fl_display, &tmpwin, &tmp);
		lyxerr[Debug::INFO] << "tmpwin: " << long(tmpwin) << '\n';
		lyxerr[Debug::INFO] << "window: "
				    << long(owner_->getForm()->window) << '\n';
		lyxerr[Debug::INFO] << "work_area_focus: "
				    << work_area_focus << '\n';
		lyxerr[Debug::INFO] << "lyx_focus      : "
				    << lyx_focus << '\n';
		if (tmpwin != owner_->getForm()->window) {
			lyx_focus = false;
			goto skip_timer;
		} else {
			lyx_focus = true;
			if (!work_area_focus)
				goto skip_timer;
			else
				goto set_timer_and_return;
		}
	}

  set_timer_and_return:
	timer_cursor.set(0.4);
  skip_timer:
	return;
}


void BufferView::WorkAreaButtonRelease(int x, int y, unsigned int button)
{
	if (buffer_ == 0) return;

	
	if (screen_ && the_locking_inset){
		/* we are in inset locking mode. */
		/* LyX does a kind of work-area grabbing for insets.
		   only a ButtonPress Event outside the inset will 
		   force a InsetUnlock */
		checkInsetHit(x, y); /* just to adept the coordinates */
		the_locking_inset->
			InsetButtonRelease(x, y, button);
		return;
	}
  
	selection_possible = false;
	return;
}


/* If the inset is hit, we update the coordinates to be
   relative to the inset, and return true.
   If not, the coordinates are not changed and we return false. */
bool BufferView::checkInsetHit(int &x, int &y)
{
	if (!screen_)
		return false;

	int y_tmp = y + screen_->first;

	LyXCursor cursor = text->cursor;
	if (cursor.pos 
	    < cursor.par->Last() 
	    && cursor.par->GetChar(cursor.pos) == LYX_META_INSET
	    && cursor.par->GetInset(cursor.pos)
	    && cursor.par->GetInset(cursor.pos)->Editable()) {

		// Check wether the inset was really hit
		Inset* tmpinset = cursor.par->GetInset(cursor.pos);
		LyXFont font = text->GetFont(cursor.par, cursor.pos);
		if (   x > cursor.x
		    && x < cursor.x + tmpinset->width(workarea->getPainter(), font) 
		    && y_tmp > cursor.y - tmpinset->ascent(workarea->getPainter(), font)
		    && y_tmp < cursor.y + tmpinset->descent(workarea->getPainter(), font)) {
			// now the origin of an inset
			// is on the baseline (for mathed) (Matthias)
			x = x - cursor.x;
			y = y_tmp - (cursor.y); 
			return true;
		}
	}
	return false;
}


void BufferView::cursorPrevious()
{
	if (!text->cursor.row->previous) return;
	
	long y = screen_->first;
	Row* cursorrow = text->cursor.row;
	text->SetCursorFromCoordinates(text->cursor.x_fix, y);
	text->FinishUndo();
	// This is to allow jumping over large insets.
	if ((cursorrow == text->cursor.row))
		text->CursorUp();
	
  	if (text->cursor.row->height < workarea->height())
		screen_->Draw(text->cursor.y
			      - text->cursor.row->baseline
			      + text->cursor.row->height
			      - workarea->height() + 1 );
}


void BufferView::cursorNext()
{
	if (!text->cursor.row->next) return;
	
	long y = screen_->first;
	text->GetRowNearY(y);
	Row* cursorrow = text->cursor.row;
	text->SetCursorFromCoordinates(text->cursor.x_fix, 
					 y + workarea->height());
	text->FinishUndo();
	// This is to allow jumping over large insets.
	if ((cursorrow == text->cursor.row))
		text->CursorDown();
	
 	if (text->cursor.row->height < workarea->height())
		screen_->Draw(text->cursor.y
			      - text->cursor.row->baseline);
}


bool BufferView::available() const
{
	if (buffer_ && text) return true;
	return false;
}


void BufferView::savePosition()
{
	backstack.push(currentBuffer()->getFileName(),
			text->cursor.x,
			text->cursor.y);
}


void BufferView::restorePosition()
{
	int  x, y;
	string fname = backstack.pop(&x, &y);
	
	beforeChange();
	Buffer *b = (bufferlist.exists(fname)) ? bufferlist.getBuffer(fname):
		bufferlist.loadLyXFile(fname); // don't ask, just load it
	setBuffer(b);
	text->SetCursorFromCoordinates(x, y);
	update(ResetSelection|FitCursor);
}


void BufferView::insertInset(Inset *inset, string const &lout,
			     bool /*no_table*/)
{
	// not quite sure if we want this...
	text->SetCursorParUndo();
	text->FreezeUndo();
	
	beforeChange();
	if (!lout.empty()) {
		update(ResetSelection|FitCursor);
		text->BreakParagraph();
		update(ResetSelection|FitCursor|BufferChange);
		
		if (text->cursor.par->Last()) {
			text->CursorLeft();
			
			text->BreakParagraph();
			update(ResetSelection|FitCursor|BufferChange);
		}

		int lay = textclasslist.numberOfLayout(buffer_->params.textclass, lout);
		if (lay == -1) // layout not found
			// use default layout "Standard" (0)
			lay = 0;
		
		text->SetLayout(lay);
		
		text->SetParagraph(0, 0,
				   0, 0,
				   VSpace::NONE, VSpace::NONE,
				   LYX_ALIGN_LAYOUT, 
				   string(),
				   0);
		update(ResetSelection|FitCursor|BufferChange);
		
		text->current_font.setLatex(LyXFont::OFF);
	}
	
	text->InsertInset(inset);
	update(ResetSelection|FitCursor|BufferChange);

// Commenting these two lines fixes the problem with new display inset
// inside a paragraph, not sure why. (ale 971117)
//	if (inset->Display())
//		text->CursorRight();
	
	text->UnFreezeUndo();	
}


// Open and lock an updatable inset
bool BufferView::open_new_inset(UpdatableInset* new_inset)
{
	if (the_locking_inset) {
	    if (!the_locking_inset->InsertInset(new_inset)) {
		delete new_inset;
		WriteAlert(_("Impossible Operation!"),
			   _("Cannot insert new inset inside this inside type!"),
			   _("Sorry."));
		return false;
	    }
	    return true;
	}
	beforeChange();
	text->FinishUndo();
	insertInset(new_inset);
	text->CursorLeft();
	update(ResetSelection|FitCursor|BufferChange);
    	new_inset->Edit(0, 0, 0, this);
	return true;
}


void BufferView::update(unsigned short uen)
{
	owner_->updateLayoutChoice();
	if (!text->selection && (uen & ResetSelection))
		text->sel_cursor = text->cursor;
	
	// BufferView::RebreakOnly
	freeUpdateTimer();
	text->FullRebreak();
	update();
	
	if (uen & FitCursor) {
		fitCursor();
	}
	
	if (uen & BufferChange) {
		if (buffer_->isLyxClean()) {
			buffer_->markDirty();
			owner_->getMiniBuffer()->setTimer(4);
		} else {
			buffer_->markDirty();
		}
	}
}

void BufferView::smallUpdate(signed char f)
{
	screen_->SmallUpdate();
	if (screen_->TopCursorVisible()
	    != screen_->first){
		update(f);
		return;
	}

	fitCursor();
   
	if (!text->selection)
		text->sel_cursor = 
			text->cursor;

	if (f==1 || f==-1) {
		if (currentBuffer()->isLyxClean()) {
			currentBuffer()->markDirty();
			owner_->getMiniBuffer()->setTimer(4);
		} else {
			currentBuffer()->markDirty();
		}
	}
}


void BufferView::insertCorrectQuote()
{
	char c;

	if  (text->cursor.pos )
		c = text->cursor.par->GetChar(text->cursor.pos - 1);
	else 
		c = ' ';

	insertInset(new InsetQuotes(buffer_, c, buffer_->params));
}


// Change environment depth.
// if decInc == 0, depth change taking mouse button number into account
// if decInc == 1, increment depth
// if decInc == -1, decrement depth
void BufferView::changeDepth(FL_OBJECT *ob, long decInc)
{
	int button = 1;

	/* When decInc != 0, fake a mouse button. This allows us to
	   implement depth-plus and depth-min commands. RVDK_PATCH_5. */
	/* check out wether ob is defined, too (Matthias) */ 
	if ( decInc < 0 )
		button = 0;
	else if (!decInc && ob) {
		button = fl_get_button_numb(ob);
	}
  
	if (available()) {
		screen_->hideCursor();
		update(ResetSelection|FitCursor);
		if (button == 1)
			text->IncDepth();
		else
			text->DecDepth();
		update(ResetSelection|FitCursor|BufferChange);
		owner_->getMiniBuffer()->Set(_("Changed environment depth"
				  " (in possible range, maybe not)"));
	}
}


void BufferView::melt()
{
	if (!available()) return;
	
	owner_->getMiniBuffer()->Set(_("Melt"));
	screen_->hideCursor();
	beforeChange();
	update(ResetSelection|FitCursor);
	text->MeltFootnoteEnvironment();
	update(ResetSelection|FitCursor|BufferChange);
}


void BufferView::paste()
{
	if (!available()) return;
	
	owner_->getMiniBuffer()->Set(_("Paste"));
	screen_->hideCursor();
	/* clear the selection */ 
	screen_->toggleSelection();
	text->ClearSelection();
	update(ResetSelection|FitCursor);
	
	/* paste */ 
	text->PasteSelection();
	update(ResetSelection|FitCursor|BufferChange);
	
	/* clear the selection */ 
	screen_->toggleSelection();
	text->ClearSelection();
	update(ResetSelection|FitCursor);
}


void BufferView::cut()
{
	if (!available()) return;

	screen_->hideCursor();
	update(ResetSelection|FitCursor);
	text->CutSelection();
	update(ResetSelection|FitCursor|BufferChange);
	owner_->getMiniBuffer()->Set(_("Cut"));
}


void BufferView::copy()
{
	if (!available())  return;

	text->CopySelection();
	// Clear the selection, even if mark_set.
	screen_->toggleSelection();
	text->ClearSelection();
	update(ResetSelection|FitCursor);
	owner_->getMiniBuffer()->Set(_("Copy"));
}


void BufferView::copyEnvironment()
{
	if (!available()) return;

	text->copyEnvironmentType();
	// Clear the selection, even if mark_set.
	screen_->toggleSelection();
	text->ClearSelection();
	update(ResetSelection|FitCursor);
	owner_->getMiniBuffer()->Set(_("Paragraph environment type copied"));
}


void BufferView::pasteEnvironment()
{
	if (!available()) return;

	text->pasteEnvironmentType();
	update(ResetSelection|FitCursor|BufferChange);
	owner_->getMiniBuffer()->Set(_("Paragraph environment type set"));
}


void BufferView::margin()
{
	if (!available()) return;

	owner_->getMiniBuffer()->Set(_("Inserting margin note..."));
	screen_->hideCursor();
	update(ResetSelection|FitCursor);
	text->InsertFootnoteEnvironment(LyXParagraph::MARGIN);
	update(ResetSelection|FitCursor|BufferChange);
}


void BufferView::hyphenationPoint()
{
	if (!available())  return;

	screen_->hideCursor();
	update(ResetSelection|FitCursor);
	InsetSpecialChar *new_inset = 
		new InsetSpecialChar(InsetSpecialChar::HYPHENATION);
	insertInset(new_inset);
}


void BufferView::protectedSpace()
{
	if (!available()) return;

	screen_->hideCursor();
	update(ResetSelection|FitCursor);
	InsetSpecialChar *new_inset =
		new InsetSpecialChar(InsetSpecialChar::PROTECTED_SPACE);
	insertInset(new_inset);
}


void BufferView::ldots()
{
	if (!available()) return;

	screen_->hideCursor();
	update(ResetSelection|FitCursor);
	InsetSpecialChar *new_inset = 
		new InsetSpecialChar(InsetSpecialChar::LDOTS);
	insertInset(new_inset);
}


void BufferView::endOfSentenceDot()
{
	if (!available()) return;

	screen_->hideCursor();
	update(ResetSelection|FitCursor);
	InsetSpecialChar *new_inset = 
		new InsetSpecialChar(InsetSpecialChar::END_OF_SENTENCE);
	insertInset(new_inset);
}


void BufferView::hfill()
{
	if (!available()) return;

	screen_->hideCursor();
	update(ResetSelection|FitCursor);
	//text->InsertChar(LYX_META_HFILL);
	//update(ResetSelection|FitCursor|BufferChange);
	InsetSpecialChar *new_inset =
		new InsetSpecialChar(InsetSpecialChar::HFILL);
	insertInset(new_inset);
}


void BufferView::newline()
{
	if (!available()) return;

	screen_->hideCursor();
	update(ResetSelection|FitCursor);
	text->InsertChar(LYX_META_NEWLINE);
	update(ResetSelection|FitCursor|BufferChange);
}


void BufferView::openStuff()
{
	if (!available()) return;

	owner_->getMiniBuffer()->Set(_("Open/Close..."));
	screen_->hideCursor();
	beforeChange();
	update(ResetSelection|FitCursor);
	text->OpenStuff(this);
	update(ResetSelection|FitCursor);
}


void BufferView::toggleFloat()
{
	if (!available()) return;

	owner_->getMiniBuffer()->Set(_("Open/Close..."));
	screen_->hideCursor();
	beforeChange();
	update(ResetSelection|FitCursor);
	text->ToggleFootnote();
	update(ResetSelection|FitCursor);
}


#warning split part of this into a Buffer::func
void BufferView::allFloats(FloatAct flact)
{
	if (!available()) return;
	
	LyXCursor cursor = text->cursor;
	
	switch(flact) {
	case OpenFootMargin:
		beforeChange();
		break;
	case CloseFootMargin:
		if (cursor.par->footnoteflag != LyXParagraph::NO_FOOTNOTE
		    && (cursor.par->footnotekind != LyXParagraph::FOOTNOTE
			&& cursor.par->footnotekind != LyXParagraph::MARGIN))
			toggleFloat();
		break;
	case OpenFigTab:
		beforeChange();
		break;
	case CloseFigTab:
		if (cursor.par->footnoteflag != LyXParagraph::NO_FOOTNOTE
		    && (cursor.par->footnotekind != LyXParagraph::FIG
			&& cursor.par->footnotekind != LyXParagraph::TAB
			&& cursor.par->footnotekind != LyXParagraph::WIDE_FIG
			&& cursor.par->footnotekind != LyXParagraph::WIDE_TAB
			&& cursor.par->footnotekind != LyXParagraph::ALGORITHM))
			toggleFloat();
		break;
	}

	LyXCursor tmpcursor = cursor;
	cursor.par = tmpcursor.par->ParFromPos(tmpcursor.pos);
	cursor.pos = tmpcursor.par->PositionInParFromPos(tmpcursor.pos);

	LyXParagraph *par = buffer_->paragraph;
	while (par) {
		switch (flact) {
		case OpenFootMargin:
			if (par->footnoteflag == LyXParagraph::CLOSED_FOOTNOTE
			    && par->footnotekind != LyXParagraph::FOOTNOTE 
			    && par->footnotekind !=  LyXParagraph::MARGIN) {
				if (par->previous
				    && par->previous->footnoteflag !=
				    LyXParagraph::CLOSED_FOOTNOTE){ /* should be */ 
					text->SetCursorIntern(par->previous,0);
					text->OpenFootnote();
				}
			}
			break;
		case CloseFootMargin:
			if (par->footnoteflag == LyXParagraph::OPEN_FOOTNOTE
			    && par->footnotekind != LyXParagraph::FOOTNOTE 
			    && par->footnotekind !=  LyXParagraph::MARGIN) {
				text->SetCursorIntern(par, 0);
				text->CloseFootnote();
			}
			break;
		case OpenFigTab:
			if (par->footnoteflag == LyXParagraph::CLOSED_FOOTNOTE
			    && par->footnotekind != LyXParagraph::FIG 
			    && par->footnotekind != LyXParagraph::TAB
			    && par->footnotekind != LyXParagraph::WIDE_FIG 
			    && par->footnotekind != LyXParagraph::WIDE_TAB
			    && par->footnotekind != LyXParagraph::ALGORITHM) {
				if (par->previous
				    && par->previous->footnoteflag !=
				    LyXParagraph::CLOSED_FOOTNOTE){ /* should be */ 
					text->SetCursorIntern(par->previous,0);
					text->OpenFootnote();
				}
			}
			break;
		case CloseFigTab:
			if (par->footnoteflag == LyXParagraph::OPEN_FOOTNOTE
			    && par->footnotekind != LyXParagraph::FIG 
			    && par->footnotekind != LyXParagraph::TAB
			    && par->footnotekind != LyXParagraph::WIDE_FIG 
			    && par->footnotekind != LyXParagraph::WIDE_TAB
			    && par->footnotekind != LyXParagraph::ALGORITHM) {
				text->SetCursorIntern(par, 0);
				text->CloseFootnote();
			}
			break;
		}
		par = par->next;
	}
	
	text->SetCursorIntern(cursor.par, cursor.pos);
	redraw();
	fitCursor();
}


void BufferView::foot()
{
	if (!available()) return;
	
	owner_->getMiniBuffer()->Set(_("Inserting Footnote..."));
	screen_->hideCursor();
	update(ResetSelection|FitCursor);
	text->InsertFootnoteEnvironment(LyXParagraph::FOOTNOTE);
	update(ResetSelection|FitCursor|BufferChange);
}


void BufferView::beforeChange()
{
	screen_->toggleSelection();
	text->ClearSelection();
	freeUpdateTimer();
}


void BufferView::note()
{
	InsetInfo *new_inset = new InsetInfo();
	insertInset(new_inset);
}


void BufferView::undo()
{
	if(!available()) return;

	owner_->getMiniBuffer()->Set(_("Undo"));
	screen_->hideCursor();
	beforeChange();
	update(ResetSelection|FitCursor);
	if (!text->TextUndo())
		owner_->getMiniBuffer()->Set(_("No further undo information"));
	else
		update(ResetSelection|FitCursor|BufferChange);
}


void BufferView::redo()
{
	if (the_locking_inset) {
		owner_->getMiniBuffer()
			->Set(_("Redo not yet supported in math mode"));
		return;
	}    
   
	if (!available()) return;

	owner_->getMiniBuffer()->Set(_("Redo"));
	screen_->hideCursor();
	beforeChange();
	update(ResetSelection|FitCursor);
	if (!text->TextRedo())
		owner_->getMiniBuffer()->Set(_("No further redo information"));
	else
		update(ResetSelection|FitCursor|BufferChange);
}


void BufferView::toggleAndShow(LyXFont const & font)
{
	if (!available()) return;

	if (the_locking_inset) {
		the_locking_inset->SetFont(font);
		return;
	}
	screen_->hideCursor();
	update(ResetSelection|FitCursor);
	text->ToggleFree(font);
	update(ResetSelection|FitCursor|BufferChange);
}


void BufferView::fontSize(string const & size)
{
	LyXFont font(LyXFont::ALL_IGNORE);
	font.setGUISize(size);
	toggleAndShow(font);
}


void BufferView::emph()
{
	LyXFont font(LyXFont::ALL_IGNORE);
	font.setEmph(LyXFont::TOGGLE);
	toggleAndShow(font);
}


void BufferView::noun()
{
	LyXFont font(LyXFont::ALL_IGNORE);
	font.setNoun(LyXFont::TOGGLE);
	toggleAndShow(font);
}


void BufferView::bold()
{
	LyXFont font(LyXFont::ALL_IGNORE);
	font.setSeries(LyXFont::BOLD_SERIES);
	toggleAndShow(font);
}


void BufferView::underline()
{
	LyXFont font(LyXFont::ALL_IGNORE);
	font.setUnderbar(LyXFont::TOGGLE);
	toggleAndShow(font);
}


void BufferView::code()
{
	LyXFont font(LyXFont::ALL_IGNORE);
	font.setFamily(LyXFont::TYPEWRITER_FAMILY); // no good
	toggleAndShow(font);
}


void BufferView::sans()
{
	LyXFont font(LyXFont::ALL_IGNORE);
	font.setFamily(LyXFont::SANS_FAMILY);
	toggleAndShow(font);
}


void BufferView::roman()
{
	LyXFont font(LyXFont::ALL_IGNORE);
	font.setFamily(LyXFont::ROMAN_FAMILY);
	toggleAndShow(font);
}


void BufferView::tex()
{
	LyXFont font(LyXFont::ALL_IGNORE);
	font.setLatex (LyXFont::TOGGLE);
	toggleAndShow(font);
}


void BufferView::styleReset()
{
	LyXFont font(LyXFont::ALL_INHERIT);
	toggleAndShow(font);
}


void BufferView::userFree()
{
	toggleAndShow( UserFreeFont());
}


// this should perhaps be review a bit
void BufferView::autoSave()
	// Perfect target for a thread...
{
	if (!screen_ || !available())
		return;
	
	if (buffer_->isBakClean()
	    || buffer_->isReadonly()) {
		// We don't save now, but we'll try again later
		owner_->resetAutosaveTimer();
		return;
	}

	string fname;
	
	owner_->getMiniBuffer()->Set(_("Autosaving current document..."));
	
	// create autosave filename
	fname =	OnlyPath(buffer_->getFileName());
	fname += "#";
	fname += OnlyFilename(buffer_->getFileName());
	fname += "#";
	
	// tmp_ret will be located (usually) in /tmp
	// will that we a problem?
	string tmp_ret = tmpnam(0);

	pid_t pid = fork(); // If you want to debug the autosave
	// you should set pid to -1, and comment out the
	// fork.
	if (pid == 0 || pid == -1) {
		// pid = -1 signifies that lyx was unable
		// to fork. But we will do the save
		// anyway.
		bool failed = false;
		if (!tmp_ret.empty()) {
			buffer_->writeFile(tmp_ret, 1);
			// assume successful write of tmp_ret
			if (rename(tmp_ret.c_str(), fname.c_str()) == -1) {
				failed = true;
				// most likely couldn't move between filesystems
				// unless write of tmp_ret failed
				// so remove tmp file (if it exists)
				remove(tmp_ret.c_str());
			}
		} else {
			failed = true;
		}
		
		if (failed) {
			// failed to write/rename tmp_ret so try writing direct
			if (!buffer_->writeFile(fname,
								      1)) {
				owner_->getMiniBuffer()
					->Set(_("Autosave Failed!"));
			}
		}
		if (pid == 0){
			_exit(0);
		}
	}
	buffer_->markBakClean();
	owner_->resetAutosaveTimer();
}


void BufferView::toggleReadOnly()
{
	if (buffer_->lyxvc.inUse()) {
		buffer_->lyxvc.toggleReadOnly();
	} else {
		buffer_->setReadonly(!buffer_->isReadonly());
	}
}


void BufferView::center()
{
	beforeChange();
	if (text->cursor.y > workarea->height() / 2) {
		screen_->Draw(text->cursor.y - workarea->height()/2);
	} else { // <=
		screen_->Draw(0);
	}
	update(ResetSelection|FitCursor);
	redraw();
}


void BufferView::appendix()
{
	if (available()){
		text->toggleAppendix();
		update(ResetSelection|FitCursor|BufferChange);
	}
}


void BufferView::insertTOC()
{
	Inset *new_inset = new InsetTOC(buffer_);
	insertInset(new_inset, "Standard", true);
}


void BufferView::insertLOF()
{
	Inset *new_inset = new InsetLOF(buffer_);
	insertInset(new_inset, "Standard", true);
}


void BufferView::insertLOA()
{
	Inset *new_inset = new InsetLOA(buffer_);
	insertInset(new_inset, "Standard", true);
}


void BufferView::insertLOT()
{
	Inset *new_inset = new InsetLOT(buffer_);
	insertInset(new_inset, "Standard", true);
}


void BufferView::removeErrors()
{
	// store the cursor pos
	LyXCursor cursor = text->cursor;
	LyXCursor tmpcursor = cursor;
	cursor.par = tmpcursor.par->ParFromPos(tmpcursor.pos);
	cursor.pos = tmpcursor.par->PositionInParFromPos(tmpcursor.pos);

	if (buffer_->removeAutoInsets()) {
		redraw();
		fitCursor();
	}

	// check and put the cursor back
	// avoid forbidden cursor positions caused by error removing
	if (cursor.pos > cursor.par->Last())
		cursor.pos = cursor.par->Last();
	text->SetCursorIntern(cursor.par, cursor.pos);
}


void BufferView::footMelt()
{
	if (available()
	    && !text->selection
	    && text->cursor.par->footnoteflag != LyXParagraph::NO_FOOTNOTE) {
		// only melt footnotes with FOOTMELT, not margins etc
		if(text->cursor.par->footnotekind == LyXParagraph::FOOTNOTE)
			melt();
	} else
		foot(); 
}


void BufferView::marginMelt()
{
	if (available()
	    && !text->selection
	    && text->cursor.par->footnoteflag != LyXParagraph::NO_FOOTNOTE) {
		// only melt margins
		if(text->cursor.par->footnotekind == LyXParagraph::MARGIN)
			melt();
	} else
		margin(); 
}


void BufferView::upcaseWord()
{
	update(ResetSelection|FitCursor);
	freeUpdateTimer();
	text->UpcaseWord();
	update(ResetSelection|FitCursor|BufferChange);
	setUpdateTimer();
}


void BufferView::lowercaseWord()
{
	update(ResetSelection|FitCursor);
	freeUpdateTimer();
	text->LowcaseWord();
	update(ResetSelection|FitCursor|BufferChange);
	setUpdateTimer();
}


void BufferView::capitalizeWord()
{
	update(ResetSelection|FitCursor);
	freeUpdateTimer();
	text->CapitalizeWord();
	update(ResetSelection|FitCursor|BufferChange);
	setUpdateTimer();
}


void BufferView::right(bool sel)
{
	if (!text->mark_set && !sel) 
		beforeChange();
	update(ResetSelection|FitCursor);

	// Are we entering an inset?
	if (!sel 
	    && text->cursor.pos < text->cursor.par->Last()
	    && text->cursor.par->GetChar(text->cursor.pos) == LYX_META_INSET
	    && text->cursor.par->GetInset(text->cursor.pos)
	    && text->cursor.par->GetInset(text->cursor.pos)->Editable()==2) {
		// Yes, go edit at the extreme left side of it
		Inset* tmpinset = text->cursor.par->GetInset(text->cursor.pos);
		owner_->getMiniBuffer()->Set(tmpinset->EditMessage());
		tmpinset->Edit(0, 0, 0, this);
		return;
	}
	text->CursorRight();
	text->FinishUndo();
	moveCursorUpdate(sel);
	owner_->getMiniBuffer()->Set(currentState(this));
}


void BufferView::left(bool sel)
{
	if (!text->mark_set && !sel) 
		beforeChange();
	update(ResetSelection|FitCursor);
	text->CursorLeft();

	// Are we entering an inset?
	if (!sel 
	    && text->cursor.pos < text->cursor.par->Last()
	    && text->cursor.par->GetChar(text->cursor.pos) == LYX_META_INSET
	    && text->cursor.par->GetInset(text->cursor.pos)
	    && text->cursor.par->GetInset(text->cursor.pos)->Editable()==2) {
		// Yes, go edit at the extreme right side of it
		Inset* tmpinset = text->cursor.par->GetInset(text->cursor.pos);
		owner_->getMiniBuffer()->Set(tmpinset->EditMessage());
		LyXFont font = text->GetFont(text->cursor.par, text->cursor.pos);
		tmpinset->Edit(tmpinset->width(workarea->getPainter(), font), 0, 0, this);
		return;
	}
	text->FinishUndo();
	moveCursorUpdate(sel);
	owner_->getMiniBuffer()->Set(currentState(this));
}
	

void BufferView::up(bool sel)
{
	if (!text->mark_set && !sel) beforeChange();
	if (sel) update(ResetSelection|FitCursor); else update(RebreakOnly);
	text->CursorUp();
	text->FinishUndo();
	moveCursorUpdate(sel);
	owner_->getMiniBuffer()->Set(currentState(this));
}


void BufferView::down(bool sel)
{
	if(!text->mark_set && !sel) beforeChange();
	if (sel) update(ResetSelection|FitCursor); else update(RebreakOnly);
	text->CursorDown();
	text->FinishUndo();
	moveCursorUpdate(sel);
	owner_->getMiniBuffer()->Set(currentState(this));
}

	
void BufferView::upParagraph(bool sel)
{
	if(!text->mark_set && !sel) beforeChange();
	if (sel) update(ResetSelection|FitCursor); else update(RebreakOnly);
	text->CursorUpParagraph();
	text->FinishUndo();
	moveCursorUpdate(sel);
	owner_->getMiniBuffer()->Set(currentState(this));
}


void BufferView::downParagraph(bool sel)
{
	if(!text->mark_set && !sel) beforeChange();
	if (sel) update(ResetSelection|FitCursor); else update(RebreakOnly);
	text->CursorDownParagraph();
	text->FinishUndo();
	moveCursorUpdate(sel);
	owner_->getMiniBuffer()->Set(currentState(this));
}


void BufferView::prior(bool sel)
{
	if(!text->mark_set && !sel) beforeChange();
	if (sel) update(ResetSelection|FitCursor); else update(RebreakOnly);
	cursorPrevious();
	text->FinishUndo();
	moveCursorUpdate(sel);
	owner_->getMiniBuffer()->Set(currentState(this));
}


void BufferView::next(bool sel)
{
	if(!text->mark_set && !sel) beforeChange();
	if (sel) update(ResetSelection|FitCursor); else update(RebreakOnly);
	cursorNext();
	text->FinishUndo();
	moveCursorUpdate(sel);
	owner_->getMiniBuffer()->Set(currentState(this));
}


void BufferView::home(bool sel)
{
	if(!text->mark_set && !sel) beforeChange();
	update(ResetSelection|FitCursor);
	text->CursorHome();
	text->FinishUndo();
	moveCursorUpdate(sel);
	owner_->getMiniBuffer()->Set(currentState(this));
}


void BufferView::end(bool sel)
{
	if(!text->mark_set && !sel) beforeChange();
	update(ResetSelection|FitCursor);
	text->CursorEnd();
	text->FinishUndo();
	moveCursorUpdate(sel);
	owner_->getMiniBuffer()->Set(currentState(this));
}


void BufferView::tab()
{
	if(!text->mark_set) beforeChange();
	update(ResetSelection|FitCursor);
	text->CursorTab();
	text->FinishUndo();
	moveCursorUpdate(false);
	owner_->getMiniBuffer()->Set(currentState(this));
}


void BufferView::wordRight(bool sel)
{
	if(!text->mark_set && !sel) beforeChange();
	update(ResetSelection|FitCursor);
	text->CursorRightOneWord();
	text->FinishUndo();
	moveCursorUpdate(sel);
	owner_->getMiniBuffer()->Set(currentState(this));
}


void BufferView::wordLeft(bool sel)
{
	if(!text->mark_set && !sel) beforeChange();
	update(ResetSelection|FitCursor);
	text->CursorLeftOneWord();
	text->FinishUndo();
	moveCursorUpdate(sel);
	owner_->getMiniBuffer()->Set(currentState(this));
}


void BufferView::beginBuff(bool sel)
{
	if(!text->mark_set && !sel) beforeChange();
	update(ResetSelection|FitCursor);
	text->CursorTop();
	text->FinishUndo();
	moveCursorUpdate(sel);
	owner_->getMiniBuffer()->Set(currentState(this));
}


void BufferView::endBuff(bool sel)
{
	if(!text->mark_set && !sel) beforeChange();
	update(ResetSelection|FitCursor);
	text->CursorBottom();
	text->FinishUndo();
	moveCursorUpdate(sel);
	owner_->getMiniBuffer()->Set(currentState(this));
}


void BufferView::insertSpecialChar(LYX_META_KIND kind)
{
	beforeChange();
	text->InsertChar(kind);
	smallUpdate(1);
	setUpdateTimer(0.01);
	moveCursorUpdate(false);
}


bool BufferView::setMark()
{
	bool mark_set = false;
	if(text->mark_set) {
		beforeChange();
		update(ResetSelection|FitCursor);
		mark_set = false;
	} else {
		beforeChange();
		text->mark_set = 1;
		update(ResetSelection|FitCursor);
		mark_set = true;
	}
	text->sel_cursor = text->cursor;
	return mark_set;
}


void BufferView::regionDelete()
{
	freeUpdateTimer();
	if (!text->selection) {
		text->Delete();
		text->sel_cursor = text->cursor;
		smallUpdate(1);
		// It is possible to make it a lot faster still
		// just comment out the lone below...
		screen_->showCursor();
	} else {
		cut();
	}
	setUpdateTimer();
}


void BufferView::regionDeleteSkip()
{
	// Reverse the effect of LFUN_BREAKPARAGRAPH_SKIP.
	
	LyXCursor cursor = text->cursor;
	
	freeUpdateTimer();
	if (!text->selection) {
		if (cursor.pos == cursor.par->Last()) {
			text->CursorRight();
			cursor = text->cursor;
			if (cursor.pos == 0
			    && !(cursor.par->pparams.added_space_top 
				 == VSpace (VSpace::NONE))) {
				text->SetParagraph(cursor.par->pparams.line_top,
						   cursor.par->pparams.line_bottom,
						   cursor.par->pparams.pagebreak_top, 
						   cursor.par->pparams.pagebreak_bottom,
						   VSpace(VSpace::NONE), 
						   cursor.par->pparams.added_space_bottom,
						   cursor.par->pparams.align, 
						   cursor.par->labelwidthstring, 0);
				text->CursorLeft();
				update (1);
			} else {
				text->CursorLeft();
				text->Delete();
				text->sel_cursor = text->cursor;
				smallUpdate(1);
			}
		} else {
			text->Delete();
			text->sel_cursor = text->cursor;
			smallUpdate(1);
		}
	} else {
		cut();
	}
	setUpdateTimer();
}


void BufferView::deleteWordForward()
{
	update(ResetSelection|FitCursor);
	freeUpdateTimer();
	text->DeleteWordForward();
	update( 1 );
	setUpdateTimer();
	moveCursorUpdate(false);
}


void BufferView::deleteWordBackward()
{
	update(ResetSelection|FitCursor);
	freeUpdateTimer();
	text->DeleteWordBackward();
	update( 1 );
	setUpdateTimer();
	moveCursorUpdate(false);
}


void BufferView::deleteLineForward()
{
	freeUpdateTimer();
	update(ResetSelection|FitCursor);
	text->DeleteLineForward();
	update( 1 );
	setUpdateTimer();
	moveCursorUpdate(false);
}


void BufferView::markOff()
{
	beforeChange();
	update(ResetSelection|FitCursor);
	text->sel_cursor = text->cursor;
}


void BufferView::markOn()
{
	beforeChange();
	text->mark_set = 1;
	update( 0 );
	text->sel_cursor = text->cursor;
}


void BufferView::backspace()
{
	freeUpdateTimer();
	if (!text->selection) {
		if (owner_->getIntl().getTrans()->backspace()) {
			text->Backspace();
			text->sel_cursor = text->cursor;
			smallUpdate(1);
				// It is possible to make it a lot faster still
				// just comment out the lone below...
			screen_->showCursor();
		}
	} else {
		cut();
	}
	setUpdateTimer();
}


void BufferView::backspaceSkip()
{
	// Reverse the effect of LFUN_BREAKPARAGRAPH_SKIP.
	
	LyXCursor cursor = text->cursor;
	
	freeUpdateTimer();
	if (!text->selection) {
		if (cursor.pos == 0 
		    && !(cursor.par->pparams.added_space_top 
			 == VSpace (VSpace::NONE))) {
			text->SetParagraph 
				(cursor.par->pparams.line_top,      
				 cursor.par->pparams.line_bottom,
				 cursor.par->pparams.pagebreak_top, 
				 cursor.par->pparams.pagebreak_bottom,
				 VSpace(VSpace::NONE), cursor.par->pparams.added_space_bottom,
				 cursor.par->pparams.align, 
				 cursor.par->labelwidthstring, 0);
			update (1);
		} else {
			text->Backspace();
			text->sel_cursor 
				= cursor;
			smallUpdate(1);
		}
	} else
		cut();
	setUpdateTimer();
}


void BufferView::paragraphBreak(bool keep_layout)
{
	beforeChange();
	text->BreakParagraph(keep_layout);
	smallUpdate(1);
	setUpdateTimer(0.01);
	text->sel_cursor = text->cursor;
}


void BufferView::paragraphBreakSkip()
{
	// When at the beginning of a paragraph, remove
	// indentation and add a "defskip" at the top.
	// Otherwise, do the same as LFUN_BREAKPARAGRAPH.
	
	LyXCursor cursor = text->cursor;

	beforeChange();
	if (cursor.pos == 0) {
		if (cursor.par->pparams.added_space_top == VSpace(VSpace::NONE)) {
			text->SetParagraph
				(cursor.par->pparams.line_top,      
				 cursor.par->pparams.line_bottom,
				 cursor.par->pparams.pagebreak_top, 
				 cursor.par->pparams.pagebreak_bottom,
				 VSpace(VSpace::DEFSKIP), cursor.par->pparams.added_space_bottom,
				 cursor.par->pparams.align, 
				 cursor.par->labelwidthstring, 1);
			update(ResetSelection|FitCursor|BufferChange);
		} 
	} else {
		text->BreakParagraph(false);
		smallUpdate(1);
	}
	setUpdateTimer(0.01);
	text->sel_cursor = cursor;
}


void BufferView::insertChar(char c)
{
	beforeChange();
	text->InsertChar(c);
	smallUpdate(1);
	setUpdateTimer();
	moveCursorUpdate(false);
}


char BufferView::getCurrentChar()
{
	char retc = '\0';
	int pos = text->cursor.pos;
	if(pos < text->cursor.par->last())
		retc = text->cursor.par->textvec[pos];
	return retc;
}


void BufferView::selfInsert(string const &txt)
{
	for (unsigned int i=0; i<txt.length(); ++i) {
		text->InsertChar(txt[i]);
		// This needs to be in the loop, or else we
		// won't break lines correctly. (Asger)
		smallUpdate(1);
	}
	setUpdateTimer();
	text->sel_cursor = text->cursor;
	moveCursorUpdate(false);
}


// I changed this func slightly. I commented out the ...FinishUndo(),
// this means that all places that used to have a moveCursorUpdate, now
// have a ...FinishUndo() as the preceeding statement. I have also added
// a moveCursorUpdate to some of the functions that updated the cursor, but
// that did not show its new position.
void BufferView::moveCursorUpdate(bool selecting)
{
	if (selecting || text->mark_set) {
		text->SetSelection();
		screen_->ToggleToggle();
	}
	update(ResetSelection|FitCursor);
	screen_->showCursor();
	updateScrollbar();
}


void BufferView::updateInset(Inset* inset, bool mark_dirty)
{
	if (!inset)
		return;

	/* very first check for locking insets*/
	if (the_locking_inset) {
	    if (the_locking_inset == inset) {
		if (text->UpdateInset(inset)){
		    update();
		    if (mark_dirty){
			if (buffer_->isLyxClean())
			    owner_->getMiniBuffer()->setTimer(4);
			buffer_->markDirty();
		    }
		    updateScrollbar();
		    return;
		}
	    } else if (the_locking_inset->UpdateInsetInInset(this,inset)) {
		if (text->UpdateInset(the_locking_inset)) {
		    update();
		    if (mark_dirty){
			if (buffer_->isLyxClean())
			    owner_->getMiniBuffer()->setTimer(4);
			buffer_->markDirty();
		    }
		    updateScrollbar();
		    return;
		}
	    }
	}
  
	// First check the current buffer
	if (available()){
		screen_->hideCursor();
		update(RebreakOnly);
		if (text->UpdateInset(inset)){
			if (mark_dirty)
				update(ResetSelection|FitCursor|BufferChange);
			else 
				update(ResetSelection);
			return;
		}
	}
  
	// check all buffers
	bufferlist.updateInset(inset, mark_dirty);
}


/* these functions return 1 if an error occured, 
   otherwise 0 */
bool BufferView::lockInset(UpdatableInset* inset)
{
	if (!the_locking_inset && inset){
		the_locking_inset = inset;
		return false;
	}
	return true;
}


void BufferView::showLockedInsetCursor(long x, long y, int asc, int desc)
{
	if (the_locking_inset && screen_){
		y += text->cursor.y +
		    the_locking_inset->InsetInInsetY();
		screen_->ShowManualCursor(x, y,
					  asc, desc);
	}
}


void BufferView::hideLockedInsetCursor(long x, long y, int asc, int desc)
{
	if (the_locking_inset && screen_){
		y += text->cursor.y;
		screen_->HideManualCursor(x, y,
					  asc, desc);
	}
}


void BufferView::fitLockedInsetCursor(long x, long y, int asc, int desc)
{
	if (the_locking_inset && screen_){
		y += text->cursor.y;
		if (screen_->FitManualCursor(x, y, asc, desc))
			updateScrollbar();
	}
}


int BufferView::unlockInset(UpdatableInset* inset)
{
	if (inset && the_locking_inset == inset){
		inset->InsetUnlock();
		the_locking_inset = 0;
		text->FinishUndo();
		return 0;
	} else if (the_locking_inset) {
	    if (the_locking_inset->UnlockInsetInInset(inset))
		return 0;
	}
	return bufferlist.unlockInset(inset);
}


void BufferView::lockedInsetStoreUndo(Undo::undo_kind kind)
{
	// we have a bug if this is called for a non updateble inset
	Assert(the_locking_inset);

	if (kind == Undo::EDIT) // in this case insets would not be stored!
		kind = Undo::FINISH;
	text->SetUndo(kind,
		      text->cursor.par->
		      ParFromPos(text->cursor.pos)->previous, 
		      text->cursor.par->
		      ParFromPos(text->cursor.pos)->next); 
}


void BufferView::putInsetIntoInsetUpdateList(Inset* inset)
{
	if (inset) {
		InsetUpdateStruct* tmp = new InsetUpdateStruct();
		tmp->inset = inset;
		tmp->next = InsetUpdateList;
		InsetUpdateList = tmp;
	}
}


void BufferView::updateInsetUpdateList()
{
	InsetUpdateStruct *tmp;
	while (InsetUpdateList) {
		tmp = InsetUpdateList;
		updateInset(tmp->inset, false); // "false" because no document change
		InsetUpdateList = InsetUpdateList->next;
		delete tmp;
	}
	InsetUpdateList = 0;
}


void BufferView::freeUpdateTimer()
{
	/* a real free timer would be better but I don't know 
	 * how to do this with xforms */
	updatetimer = false;
}


void BufferView::setUpdateTimer(float time)
{
	timer_update.set(time);
	updatetimer = true;
}



int BufferView::getMaxWidth(UpdatableInset* inset) const
{
	// Only valid if there is a locking inset
	if (!the_locking_inset) {
		lyxerr << "BufferView: No locking inset in this bufferview.\n";
		return workarea->workWidth() - 40;
	}
	
	if (the_locking_inset==inset) 
		return workarea->workWidth() - 40;
	
	return the_locking_inset->getMaxWidth(inset);
}



static signed char latin2greek[] =  {
  0, 1, 25, 3, 4, 23, 2, 7, 10, 24, 11, 12, 13, 14, -1, 16, 8, 18,
  19, 21, 22, 17, 27, 15, 26, 6
};

 
static signed char Latin2Greek[] =  {
 -1, -1, -1, 1, -1, 8, 0, -1, -1, -1, -1, 3, -1, -1, -1,
 5, 2, -1, 6, -1, 7, -1, 10, 4, 9, -1
}; 


bool BufferView::InsertGreek(char const c)
{
   int i;
   char const *s=0;
   extern char const *latex_greek[];
   extern short greek_kb_flag;

   if ('A'<=c && c<='Z') {
      if ((i=Latin2Greek[c - 'A'])>=0)
	s = latex_greek[i];
   }   
   if ('a'<=c && c<='z') {
      if ((i=latin2greek[c - 'a'])>=0)
	s = latex_greek[i+11];
   }
   if (s) {
      InsertMathSymbol(s);
      if (greek_kb_flag<2) {
	  greek_kb_flag = 0;
	  unlockInset(the_locking_inset);   
      }
      return True;
   } else
     return False; 
}


void BufferView::InsertMathSymbol(char const* s)
{
    if (!the_locking_inset) {
	InsetFormula* new_inset = new InsetFormula();
	beforeChange();
	insertInset(new_inset);
	new_inset->Edit(0, 0, 0, this);
	new_inset->InsertSymbol(s);
    } else
	if (the_locking_inset->LyxCode()==Inset::MATH_CODE)
	    ((InsetFormula*)the_locking_inset)->InsertSymbol(s);
    //        else 
	    //	    fprintf(stderr, "Math error: attempt to write on a wrong class of inset.\n");
}

Painter & BufferView::getPainter()
{
	return workarea->getPainter();
}
