// -*- C++ -*-
/* This file is part of
 * ======================================================
 * 
 *           LyX, The Document Processor
 *	     Copyright (C) 1995 Matthias Ettrich
 *           Copyright (C) 1995-1999 The LyX Team.
 *        
 *           This file is Copyright (C) 1996-1999
 *           Lars Gullik Bjnnes
 *
 * ======================================================
 */

#ifndef DEP_TABLE_H
#define DEP_TABLE_H

#include "LString.h"
#include <map>


///
class DepTable {
public:
	///
	DepTable() {}

	/** This one is a little bit harder since we need the absolute
	  filename. Should we insert files with .sty .cls etc as
	  extension? */
	void insert(string const & f,
		    unsigned long one = 0,
		    unsigned long two = 0);
	///
	void update();

	///
	void write(string const & f);
	///
	void read(string const & f);
	/// returns true if any of the files has changed
	bool sumchange();
	/// return true if the specified file has changed
	bool haschanged(string const & fil);
private:
	///
	struct sumsum {
		///
		sumsum()
			: new_sum(0), old_sum(0) {}
		///
		sumsum(unsigned long a, unsigned long b)
			: new_sum(a), old_sum(b) {}
		///
		unsigned long new_sum;
		///
		unsigned long old_sum;
	};
	///
	typedef map<string, sumsum, less<string> > DepList; 
	///
	DepList deplist;
	///
	struct update_sum;
	///
	class write_dep;
};
#endif
