// -*- C++ -*-
/* This file is part of
 * ======================================================
 * 
 *           LyX, The Document Processor
 * 	 
 *	    Copyright (C) 1998 The LyX Team
 *
 *======================================================*/

#include <config.h>

#ifdef __GNUG__
#pragma implementation
#endif

#include "FileFormat.h"
#include "filetools.h"
#include "gettext.h"

FileFormat::FileFormat(Encoding & inenc_, Encoding & outenc_)
	: inenc(&inenc_), outenc(&outenc_), file(0)
{ }


FileFormat::~FileFormat() { 
	close();
}


void FileFormat::setFile(LString const & filename) {
	file = new FilePtr(filename, FilePtr::write);
}


void FileFormat::print(char const * data) {
	errno = 0;
	fprintf((*file)(), data);
	if (errno != 0) {
		throw writeError(_("Error writing data"));
	}
}


void FileFormat::close() {
	int result = 0;
	if (file != 0) {
		result = file->close();
		delete file;
		file = 0;
	}
	if (result != 0) {
		throw writeError(_("Close not succesful"));
	}
}
