// -*- C++ -*-
/* This file is part of
 * ======================================================
 * 
 *           LyX, The Document Processor
 * 	 
 *	    Copyright (C) 1998 The LyX Team
 *
 *======================================================*/

#include <config.h>

#ifdef __GNUG__
#pragma implementation
#endif

#include "OutputController.h"
#include "gettext.h"

OutputController::OutputController(LString const & name, FileFormat * fmt) 
	: filename(name), fileformat(fmt) 
{
	fileformat->setFile(filename);
}

OutputController::~OutputController() {
	fileformat->close();
}

FileFormat::Format OutputController::format() const {
	return fileformat->kind();
}

FileFormat & OutputController::formatter() {
	return *fileformat;
}

OutputController & OutputController::operator<<(LString const & str) {
	try {
		fileformat->write(str);
	} catch (FileFormat::writeError e) {
		message(_("Failed to write to file"));
	}
	return *this;
}

OutputController & OutputController::operator<<(fmt::Symbol sym) {
	try {
		fileformat->write(sym);
	} catch (FileFormat::writeError e) {
		message(_("Failed to write to file"));
	}
	return *this;
}

void OutputController::message(LString const & message) {
	messages.push_back(message);
}

OutputController::Messages OutputController::getMessages() const {
	return messages;
}
