#include <stdio.h>
#include "LString.h"


// This file is not yet ready. See what it does already with:
// gcc -o pap -I./ PaperParams.C LString.C


// I'm using our old binary search, not sure we should 
// use STL map yet.  [ale980526].

enum PaperParamEnum {
    PAPER_UNKNOWN,
    PAPER_GEOMETRY,
    PAPER_HEIGHT,
    PAPER_WIDTH,
    PAPER_LEFTM,
    PAPER_RIGHTM,
    PAPER_ORIENTATION,
    PAPER_PACKAGE,
    PAPER_SIZE,
    PAPER_SIZE2,
    PAPER_FOOTSKIP,
    PAPER_HEADHEIGHT,
    PAPER_HEADSEP,
    PAPER_TOPM,
    PAPER_BOTTOMM,
};


///
enum PaperSizeEnum {
	///
	PAPER_DEFAULT,
	///
	PAPER_CUSTOM,
	///
	PAPER_USLETTER,
	///
	PAPER_USLEGAL,
	///
	PAPER_USEXECUTIVE,
	///
	PAPER_A3,
	///
	PAPER_A4,
	///
	PAPER_A5,
	///
	PAPER_B3,
	///
	PAPER_B4,
	///
	PAPER_B5,
};


///
enum PaperPackagesEnum {
	///
	PACKAGE_NONE,
	///
	PACKAGE_A4,
	///
    	PACKAGE_A4WIDE,
	///
	PACKAGE_WIDEMARGINSA4
};

///
enum PaperOrientation {
	///
	ORIENTATION_PORTRAIT,
	///
	ORIENTATION_LANDSCAPE
};

///
enum LYX_ANSWER {
	///
	LYX_NO=0,
	///
	LYX_YES=1
};


struct papermap_struct { 
    char *name; 
    PaperParamEnum t;
} papermap_table[] = {
      { "bottommargin",  PAPER_BOTTOMM },
      { "footskip",  PAPER_FOOTSKIP },
      { "geometry",  PAPER_GEOMETRY },
      { "headheight",  PAPER_HEADHEIGHT },
      { "headsep",  PAPER_HEADSEP },
      { "height",  PAPER_HEIGHT },
      { "leftmargin",  PAPER_LEFTM },
      { "orientation",  PAPER_ORIENTATION },
      { "package",  PAPER_PACKAGE },
      { "rightmargin",  PAPER_RIGHTM },
      { "size",  PAPER_SIZE },
      { "size2",  PAPER_SIZE2 },
      { "topmargin", PAPER_TOPM },
      { "width", PAPER_WIDTH },
};


// Valid variables
struct paperparam_struct { 
    char *name; 
    int t; 
} paperparam_table[] = {
    { "A3", PAPER_A3 },
    { "A4", PAPER_A4 },
    { "A5", PAPER_A5 },
    { "B3", PAPER_B3 },
    { "B4", PAPER_B4 },
    { "B5", PAPER_B5 },
    { "a4", PACKAGE_A4 },
    { "a4wide", PACKAGE_A4WIDE }, 
    { "custom", PAPER_CUSTOM },
    { "default", PAPER_DEFAULT },
    { "landscape", ORIENTATION_LANDSCAPE },
    { "no", LYX_NO },
    { "none", PACKAGE_NONE },
    { "portrait", ORIENTATION_PORTRAIT },
    { "usexecutive", PAPER_USEXECUTIVE },
    { "uslegal", PAPER_USLEGAL },
    { "usletter", PAPER_USLETTER },
    { "widemarginsa4", PACKAGE_WIDEMARGINSA4 },
    { "yes", LYX_YES },
};


PaperParamEnum getPaperTok(char *n)
{
    int idx, k = 0, l = 0, r = sizeof(papermap_table) / sizeof(papermap_struct);
    PaperParamEnum t = PAPER_UNKNOWN;
    
    while (l < r) {
	idx = (l+r)/2;
	
	k = strcmp(papermap_table[idx].name, n);
	if (k==0) {
	    t = papermap_table[idx].t;
	    break;
	} else if (k<0)
	      l = idx + 1;
	else r = idx;
    }
    return t;
}


int getPaperParam(char *n) 
{
    int idx, k = 0, l = 0, r = sizeof(paperparam_table) / sizeof(paperparam_struct);
    int t = -1;
    
    while (l < r) {
	idx = (l+r)/2;	
	k = strcmp(paperparam_table[idx].name, n);
	if (k==0) {
	    t = paperparam_table[idx].t;
	    break;
	} else if (k<0)
	      l = idx + 1;
	else r = idx;
    }
    return t;
}
    




void /*BufferParams::*/setPaper(LString s)
{
    int tn = 0, t = 0;
    LString cmd, name, arg;
    
    while (1) {
	cmd = s.token(' ', t);
	
	name = cmd.token('=', 0);
	
	if (name.empty()) 
	  break;
	
	arg = cmd.token('=', 1);
	printf("%s = %s, %d %d|\n", name.c_str(),  arg.c_str(), getPaperTok(name.c_str()), getPaperParam(arg.c_str()));
	
/*	
	switch (papermap[name]) { 
	 case PAPER_GEOMETRY:
	    use_geometry = (arg == "yes");
	    break;
	 case PAPER_HEIGHT: 
	    paperheight = arg;
	    break;
	 case PAPER_WIDTH: 
	    paperwidth = arg; 
	    break;
	 case PAPER_LEFTM: 
	    leftmargin = arg;
	    break;
	 case PAPER_RIGHTM: 
	    rightmargin = arg;
	    break;
	 case PAPER_ORIENTATION: 
	    orientation = (arg == "landscape") ? ORIENTATION_LANDSCAPE: ORIENTATION_PORTRAIT;
	    break;
	 case PAPER_PACKAGE: 
	    paperpackage = atoi(arg.c_str()); 
	    break;
	 case PAPER_SIZE: 
	    papersize = atoi(arg.c_str()); 
	    break;
	 case PAPER_SIZE2: 
	    papersize2 = atoi(arg.c_str());
	    break;
	 case PAPER_FOOTSKIP: 
	    footskip = arg; 
	    break;
	 case PAPER_HEADHEIGHT: 
	    headheight = arg; 
	    break;
	 case PAPER_HEADSEP: 
	    headsep = arg; 
	    break;
	 case PAPER_TOPM: 
	    topmargin = arg; 
	    break;
	 case PAPER_BOTTOMM:
	    bottommargin = arg; 
	    break;
	}*/
	t++;
    } 
}


// If list is true, return a list of all the valid options
// for the parameter, ie: if name=papersize return "a4 usletter ... etc."
LString /*BufferParams::*/getPaper(LString name, bool list)
{    
    int tn = 0, t;
    static LString arg;

    /*
    switch (papermap[name]) { 
     case PAPER_GEOMETRY:
	arg = (use_geometry) ? "yes": "no";
	break;
     case PAPER_HEIGHT: 
	arg = paperheight;
	break;
     case PAPER_WIDTH: 
	arg = paperwidth; 
	break;
     case PAPER_LEFTM: 
	arg = leftmargin;
	break;
     case PAPER_RIGHTM: 
	arg = rightmargin;
	break;
     case PAPER_ORIENTATION: 
	arg = (orientation==ORIENTATION_LANDSCAPE) ? "landscape": "portrait";
	break;
     case PAPER_PACKAGE: 
	arg = paperpackage;
	break;
     case PAPER_SIZE: 
	arg = papersize;
	break;
     case PAPER_SIZE2: 
	arg = papersize2;
	break;
     case PAPER_FOOTSKIP: 
	arg = footskip; 
	break;
     case PAPER_HEADHEIGHT: 
	arg = headheight; 
	break;
     case PAPER_HEADSEP: 
	arg = headsep; 
	break;
     case PAPER_TOPM: 
	arg = topmargin; 
	break;
     case PAPER_BOTTOMM:
	arg = bottommargin; 
	break;
    }*/
    
    return arg;
}


void main() {
	printf("paper-set orientation=landscape geometry=yes size=usletter\n");
	setPaper("orientation=landscape geometry=yes size=usletter");
	printf("paper-get size\n");
	getPaper("size", true);	
}

