// -*- C++ -*-
/* This file is part of
 * ======================================================
 * 
 *           LyX, The Document Processor
 * 	 
 *	    Copyright (C) 1999 Asger Alstrup Nielsen
 *
 *======================================================*/

#include <config.h>

#ifdef __GNUG__
#pragma implementation
#endif

#include "EncLatin1.h"

/// Convert a string to unicode.  
std::pair<wstring, LString::const_iterator>
EncLatin1::toUnicode(LString const & s) {
	wstring result;
	for (string::const_iterator i = s.begin();
	     i != s.end(); ++i) {
		wstring glyph(1, *i);
		result += glyph;
	}
	return std::make_pair(result, s.end());
}

/// Convert a string from unicode
std::pair<LString, wstring::const_iterator>
EncLatin1::fromUnicode(wstring const & s) {
	LString result;
	result.reserve(s.size());
	wstring::const_iterator i = s.begin();
	for (; i != s.end(); ++i) {
		if (*i < 0x100) {
			result += char(*i);
		} else
			break;
	}
	return std::make_pair(result, i);
}
