/* This file is part of
 * ======================================================
 * 
 *           LyX, The Document Processor
 *        
 *           Copyright (C) 1995 Matthias Ettrich
 *           Copyright (C) 1995-1998 The LyX Team.
 *
 * ====================================================== */

#include <config.h>

#ifdef __GNUG__
#pragma implementation
#endif


#include "frame.h"
#include "LyXView.h"

// This is temporary.
BufferView *current_view;

FrameHandler::FrameHandler(LyXView * o, int xpos, int ypos,
			   int width, int height)
	: owner(o)
{
	current = new BufferView(owner, xpos, ypos, width, height);
	viewList.insert(viewList.begin(), current);
	::current_view = current;
}


FrameHandler::~FrameHandler()
{
	// Here we need to delete all the BufferViews, unless we store the
	// objects and not the pointers in viewList.
}


void FrameHandler::splitHorizontally()
{
	// resize the old window to take half the space
	int w = current->width() / 2;
	int h = current->height();
	int xpos = current->xpos();
	int ypos = current->ypos();

	current->resize(xpos, ypos, w, h);
	// make a new bufferview and add it to the list
	fl_addto_form(owner->getForm());
	ViewList::iterator it = viewList.insert(viewList.begin(),
						new BufferView(owner,
							       xpos + w, ypos,
							       w, h));
		
	fl_end_form();
	// set this new bufferview to view the same buffer as current
	::current_view = (*it);
	(*it)->setBuffer(current->currentBuffer());
	::current_view = current;
	current->setFocus();
}


void FrameHandler::splitVertically()
{
	// resize the old window to take half the space
	int w = current->width();
	int h = current->height() / 2;
	int xpos = current->xpos();
	int ypos = current->ypos();

	current->resize(xpos, ypos, w, h);
	// make a new bufferview and add it to the list
	fl_addto_form(owner->getForm());
	ViewList::iterator it = viewList.insert(viewList.begin(),
						new BufferView(owner,
							       xpos, ypos + h,
							       w, h));
	fl_end_form();
	// set this new bufferview to view the same buffer as current
	::current_view = (*it);
	(*it)->setFocus();
	(*it)->setBuffer(current->currentBuffer());
	::current_view = current;
	current->setFocus();
}
