/* libgui.h
 * gather the gui headers etc here.
 */

#ifndef LIBGUI_H
#define LIBGUI_H

#include "filebrowser.h"

#include <X11/Xlib.h>
#include <X11/cursorfont.h>

class LyXRC;

extern void setXwatchCursor(Display *display, Window win);
extern void setXtermCursor(Display *display, Window win);

FileBrowser *showFileBrowser(const string &fil, const string &title);

void GUI_defaults();
void GUI_initialize(int *argc, char *argv[]);
void GUI_runtime();
void GUI_postlyxrc(LyXRC const &);

/* This is probably the best place to define the signals for:
 *     UpdateAllVisibleBufferRelatedPopups,  [call all update()]
 *     CloseAllVisibleBufferRelatedPopups,   [call all hide()]
 *     ShutdownGUI,                          [call all free()]
 *     NewParagraphEntered,                  [call paragraph.update()...]
 *     TableEntered,  [maybe?  call table.update()...]
 *     TableExited,   ["]
 *     (others?)
 * connections are then done in the LyXGUI.init() call
 * and then we'd have a simple way for LyX to tell the GUI
 * its shutting down or a different buffer has been entered.
 * These calls can be used both by the libLyX code and the
 * various popups/toolbars/etc. within the gui.
 */
#endif
