/* latexpreamble.C
 * LaTeXPreamble Interface Class Implementation
 */

#include <config.h>
#include "lyx_gui_misc.h"
#include "gettext.h"

#include FORMS_H_LOCATION
#include "LaTeXPreambleDialog.h"

#define GuiDepLaTeXPreamble LaTeXPreambleDialog

#include "latexpreamble.h"

#include "LyXView.h"
#include "BufferView.h"
#include "buffer.h"


LaTeXPreamble::LaTeXPreamble()
{
	/* nothing to do? */
	popup = 0;  // just to be certain
	l_view = 0;
}


LaTeXPreamble::~LaTeXPreamble()
{
	free();
}


void LaTeXPreamble::show(LyXView * lv)
{
	l_view = lv;
	if (!popup) {
		popup = new LaTeXPreambleDialog( l_view );
	}
	update();  // make sure its up-to-date
	// start as modal dialog
	// this sucks but its the way its written in KLyX
	popup->exec();
}


void LaTeXPreamble::hide()
{
	// can't see anyway to simply hide it so I'll just
	free(); // delete it instead
}


      //////////////////////////////////////////////////////////////
     // This code used to return a bool when it was in           //
    // UpdateLayoutPreamble() but signals are only sent to      //
   // functions/methods that don't return anything.            //
  // Thus we must resort to extra bools like the one added to //
 // the definition of fd_form_preamble.                      //
//////////////////////////////////////////////////////////////

void LaTeXPreamble::update()
{
	if (popup
	    && l_view->currentView()->available()) {
		popup->setPreamble(l_view->currentBuffer()->params.preamble.c_str());
		if (l_view->currentBuffer()->isReadonly()) {
			popup->deactivate();
		} else {
			popup->activate();
		}
	}
}


void LaTeXPreamble::free()
{
//	if (popup) {
//		delete popup;  //segfaults at exit if I do this!
//		popup = 0;
//	}
	popup = 0; //this is what Qt examples do!
}

