#include <config.h>
#include "libgui.h"

static inline
Cursor makeXCursor(Display *display, unsigned int shape)
{
	return XCreateFontCursor(display, shape);
}


void setXwatchCursor(Display *display, Window win)
{
	static Cursor cursor;
	static bool cursor_defined = false;
   
	if (!cursor_defined){
		cursor = makeXCursor(display, XC_watch);
		cursor_defined = true;
	}
	XDefineCursor(display, win, cursor);
}


void setXtermCursor(Display *display, Window win)
{
	static Cursor cursor;
	static bool cursor_defined = false;
	if (!cursor_defined){
		cursor = makeXCursor(display, XC_xterm);
		cursor_defined = true;
	}
	XDefineCursor(display, win, cursor);
}
