#include <config.h>
#include FORMS_H_LOCATION
#include "libgui.h"
#include "LString.h"
#include "lyxrc.h"
#include "debug.h"
#include "print_form.h"

extern FD_form_print *fd_form_print;
extern FD_form_sendto *fd_form_sendto;

void GUI_postlyxrc(LyXRC const &lrc)
{
	// Set the font name for popups and menus
        string menufontname = lrc.menu_font_name 
		+ "-*-*-*-?-*-*-*-*-"  
		+ lrc.font_norm; 
		// "?" means "scale that font"
	string popupfontname = lrc.popup_font_name
		+ "-*-*-*-?-*-*-*-*-"
		+ lrc.font_norm;
        if (fl_set_font_name(FL_BOLD_STYLE, menufontname.c_str()) < 0)
                lyxerr << "Could not set menu font to " 
		       << menufontname << '\n';
	if (fl_set_font_name(FL_NORMAL_STYLE, popupfontname.c_str()) < 0)
		lyxerr << "Could not set popup font to "
		       << popupfontname << '\n';

 	// put here (after fl_initialize) to avoid segfault. Cannot be done
	// in setDefaults() (Matthias 140496)
	// Moved from ::LyXGUI to ::init to allow popup font customization 
	// (petr 120997).
 	fl_setpup_fontstyle(FL_NORMAL_STYLE);
 	fl_setpup_fontsize(FL_NORMAL_SIZE);
 	fl_setpup_color(FL_MCOL,FL_BLACK);
	fl_set_goodies_font(FL_NORMAL_STYLE, FL_NORMAL_SIZE);

        // all lyxrc settings has to be done here as lyxrc has not yet
        // been read when the GUI is created (Jug)

	// the print form
	fl_set_input(fd_form_print->input_printer, 
		     lrc.printer.c_str());	
        
	// the sendto form
        if (!lrc.custom_export_command.empty())
                fl_set_input(fd_form_sendto->input_cmd,
                             lrc.custom_export_command.c_str());
	if (lrc.custom_export_format == "lyx")
		fl_set_button(fd_form_sendto->radio_ftype_lyx, 1);
	else if (lrc.custom_export_format == "tex")
		fl_set_button(fd_form_sendto->radio_ftype_latex, 1);
	else if (lrc.custom_export_format == "dvi")
		fl_set_button(fd_form_sendto->radio_ftype_dvi, 1);
	else if (lrc.custom_export_format == "ps")
		fl_set_button(fd_form_sendto->radio_ftype_ps, 1);
        else if (lrc.custom_export_format == "ascii")
                fl_set_button(fd_form_sendto->radio_ftype_ascii, 1);
}
