// -*- C++ -*-

#ifndef BROWSERBASE_H
#define BROWSERBASE_H

#ifdef __GNUG__
#pragma interface
#endif

#include "lsignal.h"
#include "LString.h"
#include FORMS_H_LOCATION

///
class BrowserBase {
public:
	///
	BrowserBase(const string &f, const string &t);
	///
	~BrowserBase();
	///
	void hide();
	///
	void update(const string &f = string());
	/// show the popup
	void show(const string &f = string(), const string &t = string());
	///
	Signal0 Closing;
private:
	///
	string fname;
	///
	string title;
	
	/// Build the popup
	void build();
	/**@name Real per-instance Callback Methods */
	//@{
	static void BrowserClose(FL_OBJECT *, long);
	static void BrowserUpdate(FL_OBJECT *, long);
	static int BrowserWMClose(FL_FORM * form, void *);
	//@}
	
	///
	void free();
	///
	struct FD_FileBrowser {
		FL_FORM *form;
		void *vdata;
		char *cdata;
		long  ldata;
		FL_OBJECT *browser;
	};
	
	///
	FD_FileBrowser *popup;
};
#endif
