// -*- C++ -*-
/* form_copyright.h
 * FormCopyright Interface Class
 */

#ifndef FORMCOPYRIGHT_H
#define FORMCOPYRIGHT_H

#include "lsignal.h"
#include "gui_common.h"

class Communicator;
class Popups;

/** This class provides an XForms implementation of the FormCopyright Popup.
 */
class FormCopyright : public virtual SignalBase {
public:
	/**@name Constructors and Destructors */
	//@{
	/// #FormCopyright x(Communicator ..., Popups ...);#
	FormCopyright(Communicator *, Popups *);
	///
	~FormCopyright();
	//@}
private:
	FormCopyright() {}
	FormCopyright(FormCopyright&) {}

	/**@name Real per-instance Callback Methods */
	//@{
	static int CopyrightWMHideCB(FL_FORM *, void *);
	static void CopyrightOKCB(FL_OBJECT *, long);
	//@}
	
	/**@name Slot Methods */
	//@{
	/// Create the popup if necessary, update it and display it.
	void show();
	/// Hide the popup.
	void hide();
	//@}

	
	/// Build the popup
	void build();
	/// Explicitly free the popup.
	void free();

	typedef struct {
		FL_FORM *form_copyright;
		void *vdata;
		char *cdata;
		long  ldata;
		FL_OBJECT *button_ok;
	} FD_form_copyright;

	/**@name Private Data */
	//@{
	/// Real GUI implementation.
	FD_form_copyright *popup;
	/// Which LyXView do we belong to?
	Communicator *comm;
	/// Hide connection.
	Connection h;
	//@}
};

#endif
