// -*- C++ -*-
/* form_credits.h
 * FormCredits Interface Class
 */

#ifndef FORMCREDITS_H
#define FORMCREDITS_H

#include "lsignal.h"
#include "gui_common.h"

class Communicator;
class Popups;

/** This class provides an XForms implementation of the FormCredits Popup.
 */
class FormCredits : public virtual SignalBase {
public:
	/**@name Constructors and Destructors */
	//@{
	/// #FormCredits x(Communicator ..., Popups ...);#
	FormCredits(Communicator *, Popups *);
	///
	~FormCredits();
	//@}
private:
	FormCredits() {}
	FormCredits(FormCredits&) {}

	/**@name Real per-instance Callback Methods */
	//@{
	static int CreditsWMHideCB(FL_FORM *, void *);
	static void CreditsOKCB(FL_OBJECT *, long);
	//@}
	
	/**@name Slot Methods */
	//@{
	/// Create the popup if necessary, update it and display it.
	void show();
	/// Hide the popup.
	void hide();
	//@}

	
	/// Build the popup
	void build();
	/// Explicitly free the popup.
	void free();

	typedef struct {
		FL_FORM *form_credits;
		void *vdata;
		char *cdata;
		long  ldata;
		FL_OBJECT *button_ok;
		FL_OBJECT *browser_credits;
	} FD_form_credits;

	/**@name Private Data */
	//@{
	/// Real GUI implementation.
	FD_form_credits *popup;
	/// Which LyXView do we belong to?
	Communicator *comm;
	/// Hide connection.
	Connection h;
	//@}
};

#endif
