
#include <config.h>
#include <stdlib.h>
#include "lyx_gui_misc.h"
#include "gettext.h"
#include FORMS_H_LOCATION
#include "latexlog.h"
#include "Popups.h"
#include "Communicator.h"
#include "filetools.h"
#include "path.h"
#include "browserbase.h"

// 	$Id: latexlog.C,v 1.5 1998/09/22 16:27:54 asger Exp $	

#if !defined(lint) && !defined(WITH_WARNINGS)
static char vcid[] = "$Id: latexlog.C,v 1.5 1998/09/22 16:27:54 asger Exp $";
#endif /* lint */

#ifdef __GNUG__
#pragma implementation
#endif


LaTeXLog::LaTeXLog(Communicator *c, Popups *p)
	: comm(c), base(0)
{
	// let the popup be shown
	// This is a permanent connection so we won't bother
	// storing a copy because we won't be disconnecting.
	connect_to_method(p->showLaTeXLog,
			  this,
			  &LaTeXLog::show);
	// NOTE:
	// parameter p is used instead of:
	//      comm->getPopups()
	// because we are being contructed from within the
	// Popups constructor and a segfault would occur
	// otherwise.  The segfault occurs because the Popups
	// constructor hasn't returned at this point and so
	// comm->getPopups() will not return the real popups
	// instance.  If this implementation fails see Popups.C
	// ARRae.
}

LaTeXLog::~LaTeXLog()
{
	delete base;
}

string LaTeXLog::fileName()
{
	if (!comm->isAvailable()) return string();
	
	string fname;
	string path;
	
	string filename = comm->getFileName();
	if (!filename.empty()) {
		fname = SpaceLess(ChangeExtension(filename, ".log", true));
		// if the path to the file needs to be changed too,
		// that should also be done here.
                // it IS needed (Jug)
                path = OnlyPath(filename);
                if (comm->usingTempDir() || (IsDirWriteable(path) < 1)) {
                    path = comm->getTmpDir();
                }
                fname = AddName(path,fname);
	}
	return fname;
}


void LaTeXLog::show()
{
	if (!base) {
		base = new BrowserBase(fileName(), string("LaTeX Log"));
		connect_to_method(base->Closing, this, &LaTeXLog::disc);
		u=connect_to_method(comm->getPopups().updateBufferDependent,
				    this,
				    &LaTeXLog::update);
		h=connect_to_method(comm->getPopups().hideBufferDependent,
				    this,
				    &LaTeXLog::hide);
	}
	base->show(fileName(),string("LaTeX Log"));
}


void LaTeXLog::update()
{
	show();
}


void LaTeXLog::hide()
{
	delete base;
	base = 0;
}


void LaTeXLog::disc()
{
	u.disconnect();
	h.disconnect();
}
