// -*- C++ -*-

#ifndef LATEXLOG_H
#define LATEXLOG_H

#include "lsignal.h"

class Popups;
class Communicator;
class BrowserBase;

/** This class proveides an XForms implementation of the LaTeXLog Popup.
  The LateXLog popup allows users access to the latex log.
  */
class LaTeXLog : public virtual SignalBase{
public:
	///
	LaTeXLog(Communicator *, Popups *);
	///
	~LaTeXLog();
private:
	LaTeXLog() {};
	LaTeXLog(LaTeXLog&) {};
	///
	Communicator *comm;
	///
	BrowserBase *base;
	/// Create the popup if necessary, update it and display it.
	void show();
	/// Update the popup.
	void update();
	///
	void hide();
	///
	void disc();
	///
	string fileName();
	///
	Connection u;
	///
	Connection h;
};
#endif
