/* splashscreen.C
 * SplashScreen Interface Class Implementation
 */

#include <config.h>
#include <stdlib.h>
#include "lyx_gui_misc.h"
#include "gettext.h"

#include "splashscreen.h"
#include FORMS_H_LOCATION
#include "form_splashscreen.h"
#include "version.h"

#include "banner.xpm"

FD_form_splashscreen *fd_form_splashscreen;

// from lyx_gui.C -- this will probably have to be changed
// to a liblyx call or we may be able to just keep it
// within the gui frontend support.  Either way we need a 
// function call to replace this.  ARRae
#if 0
extern int width, height, xpos, ypos;
#endif

SplashScreen::SplashScreen()
{
	static bool shown = 0;

	if (!shown) {
		shown = 1;
		fd_form_splashscreen = create_form_form_splashscreen();
		fl_set_object_callback(fd_form_splashscreen->timer_title,
				       SplashScreen::hideCB,0);
		fl_set_form_dblbuffer(fd_form_splashscreen->form_splashscreen,
				      1); // use dbl buffer
		fl_set_form_atclose(fd_form_splashscreen->form_splashscreen,
				    CancelCloseBoxCB, 0);
		fl_addto_form(fd_form_splashscreen->form_splashscreen);
		FL_OBJECT *obj = fl_add_pixmapbutton(FL_NORMAL_BUTTON,
						     0,0,425,290,"");
		fl_set_pixmapbutton_data(obj, (char**)banner);
		fl_set_pixmapbutton_focus_outline(obj,3);
		fl_set_button_shortcut(obj,"^M ^[",1);
		fl_set_object_boxtype(obj,FL_NO_BOX);
		fl_set_object_callback(obj,SplashScreen::hideCB,0);

		obj = fl_add_text(FL_NORMAL_TEXT,248,265,170,16, LYX_VERSION);
		fl_set_object_lsize(obj,FL_NORMAL_SIZE);
		fl_mapcolor(FL_FREE_COL2, 0x05, 0x2e, 0x4c);
		fl_mapcolor(FL_FREE_COL3, 0xe1, 0xd2, 0x9b);
		fl_set_object_color(obj,FL_FREE_COL2, FL_FREE_COL2);
		fl_set_object_lcol(obj,FL_FREE_COL3);
		fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
		fl_set_object_lstyle(obj,FL_BOLD_STYLE);
		fl_end_form();
	}
	
	if (!fd_form_splashscreen->form_splashscreen->visible) {
		int title_placement = FL_PLACE_CENTER;
#if 0
		// Did we get a valid position?
		if (xpos>=0 && ypos>=0) {
			// show the title form in the middle of the main form
			fl_set_form_position(fd_form_splashscreen->form_splashscreen,
					     abs(xpos + (width/2) - (370 / 2)),
					     abs(ypos + (height/2) - (290 / 2)));
			// The use of abs() above is a trick to ensure valid positions
			title_placement = FL_PLACE_GEOMETRY;
		}
#endif
		fl_show_form(fd_form_splashscreen->form_splashscreen, 
			     title_placement, FL_NOBORDER,
			     _("LyX Banner"));
		fl_redraw_form(fd_form_splashscreen->form_splashscreen);
	}
	// Yes, this call to raise_form *is* supposed to be here.
	fl_raise_form(fd_form_splashscreen->form_splashscreen);

	// Show the title form at most 5 secs (lowered from 10 secs)
	fl_set_timer(fd_form_splashscreen->timer_title, 5);
}


SplashScreen::~SplashScreen()
{
	hideCB(0,0);
}


void SplashScreen::raise()
{
	if (fd_form_splashscreen
	    && fd_form_splashscreen->form_splashscreen->visible) {
		fl_raise_form(fd_form_splashscreen->form_splashscreen);
	}
}


void SplashScreen::hideCB(FL_OBJECT *, long)
{
	if (fd_form_splashscreen) {
		if (fd_form_splashscreen->form_splashscreen->visible) {
			// need this because XForms is dumb.
			fl_hide_form(fd_form_splashscreen->form_splashscreen);
		}
		fl_free_form(fd_form_splashscreen->form_splashscreen);
		fd_form_splashscreen = 0;
	}
}
