// -*- C++ -*-
#ifndef _GSQUEUE_H
#define _GSQUEUE_H

#include "figlist.h"

// A queue of images to process by gs
class GSQueue {
public:
	GSQueue() {
		queue = NULL;
		gsrunning = 0;
	}
	struct Queue {
		float rx, ry;	// resolution x and y
		int ofsx, ofsy;	// x and y translation
		figdata *data;	// we are doing it for this data
		Queue *next;	// next item in queue
	};
	Queue *queue;  // queue for ghostscripting
	unsigned int gsrunning; // currently so many gs's are running

	// Are any gs processes working at the moment?
	bool gsworking() {
		return gsrunning > 0;
	}
	void runqueue();
};
extern GSQueue gsQ;

#endif
