// -*- C++ -*-
/* This file is part of
* ======================================================
* 
*           LyX, The Document Processor
* 	 
*	    Copyright (C) 1997-1998 The LyX Team.
*
*======================================================*/

#ifndef BACK_STACK_H
#define BACK_STACK_H

#include <stack>
#include <deque>
#include "LString.h"

// Created by Alejandro Aguilar Sierra, 970806

/**  Utility to get back from a reference or from a child document.
 */
class BackStack {
public:
	///
	struct BackStackItem {
		///
		BackStackItem()
			: x(0), y(0) {}
		///
		BackStackItem(string f, int xx, int yy)
			: fname(f), x(xx), y(yy) {}
		/// Filename
		string fname;
		/// Cursor x-position
		int x;
		/// Cursor y-position
		int y;   
	};

	///
	void push(string f, int x, int y) {
		const BackStackItem tmp(f, x, y);
		stakk.push(tmp);
	}
	
	///
	string pop(int *x, int *y) {
		if (!stakk.empty()) {
			BackStackItem const & tmp = stakk.top();
			string str(tmp.fname);
			*x = tmp.x;
			*y = tmp.y;
			stakk.pop();
			return str;
		} else {
			*x = 0;
			*y = 0;
			return string();
		}
	}
private:
	/// The STL distributed with gcc 2.7.x has the wrong definition
#ifdef BROKEN_STL_STACK
	stack<deque<BackStackItem> > stakk;
#else
	stack<BackStackItem> stakk;
#endif
};

#endif
