// -*- C++ -*-
/* This file is part of
 * ======================================================
 * 
 *           LyX, The Document Processor
 * 	 
 *	    Copyright (C) 1995 Matthias Ettrich
 *          Copyright (C) 1995-1998 The LyX Team.
 *
 *======================================================*/

// This one is heavily based on the substring class in The C++
// Programming Language by Bjarne Stroustrup

#ifndef LSUBSTRING_H
#define LSUBSTRING_H 

#ifdef __GNUG__
#pragma interface
#endif

#ifdef HAVE_CONFIG_H
#include <config.h> // needed at least for compilers that do not
#endif              // understand `explicit' (JMarc)


#include "LString.h"
#include "Regexp.h"

///
class LSubstring {
public:
	///
	typedef string::size_type size_type;
	///
	LSubstring(string & s, size_type i, size_type n);
	///
	LSubstring(string & s, string & s2);
	///
	LSubstring(string & s, char *p);
	///
	LSubstring(string & s, Regexp & r);
	///
	LSubstring & operator=(string const &);
	///
	LSubstring & operator=(LSubstring const &);
	///
	LSubstring & operator=(char const *);
	///
	LSubstring & operator=(char);
	///
	operator string() const;
	///
	operator char const * () const;
private:
	///
	string *ps;
	///
	size_type pos;
	///
	size_type n;
};

#endif
