// -*- C++ -*-
/* This file is part of
* ======================================================
* 
*           LyX, The Document Processor
*        
*           Copyright (C) 1995 Matthias Ettrich
*           Copyright (C) 1995-1998 The LyX Team.
*
*======================================================*/

#ifndef LYXVIEW_H
#define LYXVIEW_H

#ifdef __GNUG__
#pragma interface
#endif

#include FORMS_H_LOCATION
#include "LyXViewBase.h"
//#include "BufferView.h"

//#include "lyxfunc.h"
//class Menus;
//class Buffer;
//class Toolbar;
//class MiniBuffer;
//#include "intl.h"
//#include "Popups.h"

///
struct  FD_form_main {
	///
	FL_FORM *form_main;
	///
	FL_OBJECT *timer_autosave;
	///
	void *vdata;
	///
	long ldata;
};



/**
 * This class is the form containing the main view.
 * This includes the menu, the toolbar, the minibuffer and one (or 
 * later more) BufferView's.
 * The plan is to allow instances of LyXView's, and each will represent a
 * window.
 */
class LyXView : public LyXViewBase {
public:
	///
	LyXView(int w, int h);

	///
	~LyXView();

	/// Where to place the form.
	void setPosition(int, int);

	/// Show the main form.
	void show();

	/// init (should probably be removed later) (Lgb)
	void init();

	/// Redraw the work area form
	void redraw();

	/// returns a pointer to the form.
	FL_FORM *getForm() { return _form; }

	/// Reset autosave timer
	void resetAutosaveTimer();
private:
	///
	void invalidateLayoutChoice();
 	///
 	static int KeyPressMask_raw_callback(FL_FORM *, void *xev);
	/// makes the main form.
	void createMainWindow(int width, int height);

	/** This callback is run when a close event is sent from the
	  window manager. */
	static int atCloseMainFormCB(FL_FORM *, void *);
	///
	void set_window_title(string const &);
	
	/// A callback
	static void AutosaveTimerCB(FL_OBJECT *, long);
	/// A pointer to the form
	FD_form_main *_form_main;
	/// A pointer to the work area form
	FL_FORM *_form;

	/// position set
	bool position_set;
};

#endif
