// -*- C++ -*-
/* This file is part of
 * ======================================================
 * 
 *           LyX, The Document Processor
 * 	 
 *          Copyright (C) 1995-1999 The LyX Team.
 *
 * ======================================================*/

#ifndef REGEXP_H
#define REGEXP_H

// Simple C++ wrapper around the posix regex functions.

// Provides simple regexp matching.

#ifdef __GNUG__
#pragma interface
#endif

// Some structure in regex.h decleares pair so it must be placed before pair.h (Lgb)
// POSIX says sys/types.h has to be included before regex.h (Jochen)
#include <sys/types.h>
#include <regex.h>
#include <pair.h>
#include "LString.h"

///
class Regexp {
  public:
	///
	Regexp();
	///
	Regexp(string regex);
	///
	~Regexp();
	///
	void setRegex(string regex);
	///
	typedef pair<string::size_type, string::size_type> interval;
	///
	interval exec(string);
  private:
	///
	regex_t *preg;
	///
	regmatch_t *pmatch;
	///
	string regex_;
	///
	bool compiled;
};

#endif
