// -*- C++ -*-

#ifndef _ERROR_H_
#define _ERROR_H_

#ifdef __GNUG__
#pragma interface
#endif

#include "LString.h"


///
class Error
{
public:
	///
	enum DEBUG_LEVELS {
		///
		INFO       = (1),        // 1
		///
		INIT       = (1 << 1),   // 2
		///
		KEY        = (1 << 2),   // 4
		///
		TOOLBAR    = (1 << 3),   // 8
		///
		PARSER     = (1 << 4),   // 16
		///
		LYXRC      = (1 << 5),   // 32
		///
		KBMAP      = (1 << 6),   // 64
		///
		LATEX      = (1 << 7),   // 128
		///
		MATHED     = (1 << 8),   // 256 // Alejandro, please use this.
		///
		FONT       = (1 << 9),   // 512
		///
		TCLASS     = (1 << 10),  // 1024
		///
		LYXVC      = (1 << 11),  // 2048
		///
		LYXSERVER  = (1 << 12),  // 4096
		///
		ANY        = (65535)    // 2^16-1
	};
	///
	Error(int level = 0);
	///
	void setDebugLevel(char const *);
	///
	void showTags();
	/// Not implemented yet.
	void setLogLevel(int level);
	/// Not implemented yet.
	void setLogFile(string const & filename);
	///
	void debug(string const & msg, int level = INFO);
	///
	bool debugging(int level = INFO)
	{
		return (bool)(debuglevel & level);
	}
	///
	void print(string const & msg);
protected:
private:
	///
	int debuglevel;
	///
	int loglevel;
};

/// The global instance of the Error class.
extern Error lyxerr;

#endif
