// -*- C++ -*-
/* This file is part of
 * ======================================================
 * 
 *           LyX, The Document Processor
 *           Copyright (C) 1995 Matthias Ettrich
 *           Copyright (C) 1995-1998 The LyX Team.
 *
 *           This file is Copyright (C) 1996-1998
 *           Lars Gullik Bj<F8>nnes
 *
 * ======================================================
 */


/** This is the real float type. The one that user can generate and
 * add for themselves. Only the different float parameters are
 * defined for now.
 */
class FloatStyle {
public:
	///
	enum Placement {
		/// This is only allowed alone.
		HERE = 0,
		///
		top = 1,
		///
		bottom = 2,
		///
		page = 4,
		///
		here = 8
	};
	///
	enum Style {
		/// Only allowed for table and figure.
		none = 0,
		///
		plain = 1,
		///
		boxed = 2,
		///
		ruled = 4
	};
	///
	FloatStyle() { }
	///
	FloatStyle(const FloatStyle &);
	///
	~FloatStyle() { }
	///
	FloatStyle & operator=(const FloatStyle &);
	///
	bool operator<(const FloatStyle &fd);
private:
	///
	LString floattype;
	///
	Placement default_placement;
	///
	LString fileext; // this should be automatically generated.
#if 0
	// This is used to set numbering within a sectioning unit.
	// e.x. chapter or section. I am not totally sure how this
	// should be implemented.
	///
	LString within;
#endif
	///
	Style style;
	///
	LString floatname;
	///
	LString listtitle;
};
