// -*- C++ -*-
/* This file is part of
* ======================================================
* 
*           LyX, The Document Processor
*        
*           Copyright (C) 1995 Matthias Ettrich
*           Copyright (C) 1995-1998 The LyX Team.
*
*======================================================*/

#ifndef FRAMEHANDLER_H
#define FRAMEHANDLER_H

#ifdef __GNUG__
#pragma interface
#endif

#include <list>
#include "BufferView.h"

///
class FrameHandler {
public:
	///
	FrameHandler(LyXView *, int,int,int,int);
	///
	~FrameHandler();
	///
	FrameHandler & operator=(FrameHandler const & fh)
	{
		owner = fh.owner;
		viewList = fh.viewList;
		current = viewList.front();
		
		return *this;
	}
	
	/// Splits a window along the horizontal axis.
	void splitHorizontally();
	
	/// Splits a window along the vertical axis.
	void splitVertically();
	
	/// Deletes the window currently having focus.
	//void deleteWindow();
	
	/// Deletes all other windows except the one holding focus.
	//void deleteOtherWindows();
	
	///
	void setFocus() { current->setFocus(); }
	///
	Buffer * currentBuffer() {
		return current->currentBuffer();
	}
	///
	BufferView * currentView() {
		return current;
	}
private:
	///
	LyXView * owner;
	///
	typedef list<BufferView*> ViewList;
	///
	ViewList viewList;
	///
        BufferView * current;
};

#endif
