// -*- C++ -*-
/* This file is part of*
 * ======================================================
 *
 *           LyX, The Document Processor
 * 	 
 *	    Copyright (C) 1995 Matthias Ettrich
 *          Copyright (C) 1995-1998 The LyX Team.
 * 
 *======================================================*/

#ifndef _INSET_BIBKEY_H
#define _INSET_BIBKEY_H

#ifdef __GNUG__
#pragma interface
#endif

#include "insetcommand.h"
#include "lsignal.h"

// Created by Alejandro 970222
// Split from insetbib and gui-indep ARRae 990103

/** Used to insert bibitem's information (key and label)
  
  Must be automatically inserted as the first object in a
  bibliography paragraph.
  */
class InsetBibKey: public InsetCommand {
public:
	///
	InsetBibKey(): InsetCommand("bibitem") { counter = 1; }
	///
	InsetBibKey(string const & key, string const & label=string());
	///
	InsetBibKey(InsetBibKey const*);
	///
	~InsetBibKey();
	///
        Inset* Clone() { return new InsetBibKey(this); }
	/// Currently \bibitem is used as a LyX2.x command, so we need this method.
        void Write(FILE *);
	///
	string getScreenLabel() const;
        ///
	void Edit(int, int, unsigned int, BufferView *);
	///
	Inset::EDIT Editable() const {
		return Inset::EDITABLE;
	}
	/// A user can't neither insert nor delete this inset
	bool Deletable() const {
		return false;
	}
        ///
        void setCounter(int);
        ///
        int  getCounter() const { return counter; }
	/// Signal to tell visible gui popup the inset is being deleted
	Signal0 gone;
 private:
	///
        int counter;
};

#endif
