// -*- C++ -*-
/* This file is part of*
 * ======================================================
 *
 *           LyX, The Document Processor
 * 	 
 *	    Copyright (C) 1995 Matthias Ettrich
 *          Copyright (C) 1995-1998 The LyX Team.
 * 
 *======================================================*/

#ifndef _INSET_BIBTEX_H
#define _INSET_BIBTEX_H

#ifdef __GNUG__
#pragma interface
#endif

#include "insetcommand.h"
#include "lsignal.h"

// Created by Alejandro 970222
// Split from insetbib and gui-indep ARRae 990103

/** Used to insert BibTeX's information 
  */
class InsetBibtex: public InsetCommand {
public:
	/// 
	InsetBibtex(): InsetCommand("BibTeX") { owner = 0; }
	///
	InsetBibtex(string const & dbase, string const & style,
		    Buffer *);
        ///
        ~InsetBibtex();
        ///
	Inset* Clone() { return new InsetBibtex(contents, options, 0); }
	///  
	Inset::Code LyxCode() const
	{
		return Inset::BIBTEX_CODE;
	}
	///
	string getScreenLabel() const;
	///
	void Edit(int, int, unsigned int, BufferView *);
	/// 
	int Latex(FILE *, signed char);
	///
	int Latex(string &file, signed char fragile);
	///
	Inset::EDIT Editable() const {
		return Inset::EDITABLE;
	}
        ///
        bool addDatabase(string const&);
        ///
        bool delDatabase(string const&);
	///
	bool display() const { return true; }
	/// Signal to tell visible gui popup the inset is being deleted
	Signal0 gone;
private:
	///
	Buffer *owner;
};


#endif
