// -*- C++ -*-
/* This file is part of*
 * ======================================================
 *
 *           LyX, The Document Processor
 * 	 
 *	    Copyright (C) 1995 Matthias Ettrich
 *          Copyright (C) 1995-1998 The LyX Team.
 * 
 *======================================================*/

#ifndef _INSET_CITATION_H
#define _INSET_CITATION_H

#ifdef __GNUG__
#pragma interface
#endif

#include "insetcommand.h"
#include "lsignal.h"

// Created by Alejandro 970222
// Split and gui-indep ARRae 990103

/** Used to insert citations  
 */
class InsetCitation: public InsetCommand {
public:
	///
	InsetCitation(): InsetCommand("cite") { }
	///
	InsetCitation(string const & key, string const & note=string());
        ///
	~InsetCitation();
        ///
	Inset::Code LyxCode()
		{
			return Inset::CITATION_CODE;
		}
	
        Inset* Clone() 
		{
			return new InsetCitation(contents, options);
		}
    	///
	string getScreenLabel()const;
        ///
	void Edit(int, int, unsigned int, BufferView *);
        ///
	Inset::EDIT Editable() const 
		{
			return Inset::EDITABLE;
		}
	/// Signal to tell visible gui popup the inset is being deleted
	Signal0 gone;
};

#endif
