// -*- C++ -*-
/* This file is part of
 * ======================================================
 * 
 *           LyX, The Document Processor
 *           Copyright (C) 1995 Matthias Ettrich
 *           Copyright (C) 1995-1998 The LyX Team.
 *
 *           This file is Copyright (C) 1996-1998
 *           Lars Gullik Bj<F8>nnes
 *
 * ======================================================
 */

#ifndef INSETFLOAT_H
#deifne INSETFLOAT_H

#ifdef __GNUG__
#pragma interface
#endif

///
class InsetFloat : public UpdatableInset {
public:
	///
	InsetFloat();
	///
	virtual ~InsetFloat();
	///
	int ascent(LyXFont const &);
	///
	int descent(LyXFont const &);
	///
	int width(LyXFont const &);
	///
	void draw(Painter &, int, float &x);
	///
	LString EditMessage();
	///
	Inset::EDIT Editable() const;
	///
	void Write(FILE *file);
	///
	void Read(LyXLex &);
	///
	int Latex(FILE *file, signed char fragile);
	///
	int Latex(LString &file, signed char fragile);
	///
	void Validate(LaTeXFeatures &featurs) const;
	///
	bool Deletable() const;
	///
	Inset::Code LyxCode() const;
	///
	Inset* Clone();
	///
	bool display() const;
protected:
private:
	///
	FloatStyle *floatstyle;
};
#endif
