// -*- C++ -*-
/* This file is part of
 * ======================================================
 * 
 *           LyX, The Document Processor
 *           Copyright (C) 1998 The LyX Team.
 *
 * ======================================================
 */

#ifndef INSETFLOAT_H
#deifne INSETFLOAT_H

#ifdef __GNUG__
#pragma interface
#endif

///
class InsetFloat : public InsetCollapsable {
public:

	/** What we really want is to have this inset to be and
	    draw the float contents on the basis of FloatStyle.

	    FloatStule decides
#if 0
    ///
    enum FloatType {
	FIGURE,
	TABLE,
	WIDETABLE
    };

    ///
    enum FloatPlacement {
	Default,
	Top=1,
	Botom=2,
	Here=4,
	Page=8
    };
#endif
	
    ///
    InsetFloat(FloatType, Buffer*);
    ///
    virtual ~InsetFloat();
    ///
    int ascent(LyXFont const &);
    ///
    int descent(LyXFont const &);
    ///
    int width(LyXFont const &);
    ///
    void draw(Painter &, int, float &x);
    ///
    LString EditMessage();
    ///
    void Write(FILE *file);
    ///
    void Read(LyXLex &);
    ///
    int Latex(FILE *, signed char);
    ///
    int Latex(LString &, signed char);
    ///
    void Validate(LaTeXFeatures &) const;
    ///
    Inset::Code LyxCode() const { return FLOAT_CODE; }
    ///
    Inset* Clone();
    ///
    bool display() const { return true; }

protected:
#if 0
    ///
    FloatType float_type;
    ///
    FloatPlacement placement;
#endif
private:
};

#endif
