// -*- C++ -*-
/* This file is part of*
 * ======================================================
 *
 *           LyX, The Document Processor
 * 	 
 *	    Copyright (C) 1995 Matthias Ettrich
 *                        1996-1998 LyX Team
 * 
 *======================================================*/

#ifndef INSET_INDEX_H
#define INSET_INDEX_H

#ifdef __GNUG__
#pragma interface
#endif

#include "insetcommand.h"
#include "lsignal.h"

class Buffer;
class LaTeXFeatures;

// Created by Lgb 970227


/** Used to insert index labels  
  */
class InsetIndex: public InsetCommand {
public:
	///
	InsetIndex(): InsetCommand("index") { }
	///
	InsetIndex(string const & key);
	///
	~InsetIndex();
	///
	Inset* Clone() { return new InsetIndex(contents); }
	///
	void Edit(int, int, unsigned int, BufferView *);
	///
	Inset::EDIT Editable() const
	{
		return Inset::EDITABLE;
	}
	///
	string getScreenLabel() const;
	/// Signal to tell visible gui popup that inset is being deleted
	Signal0 gone;
private:
	///
//	struct FD_index_form {
//  		///
//  		FL_FORM *index_form;
//  		///
//  		FL_OBJECT *key;
//  		///
//  		void *vdata;
//  		///
//  		long ldata;
//  	};
//  	///
//  	FD_index_form *index_form;
//  	///
//  	void create_form_index_form(BufferView *);
//  	///
//  	static void index_cb(FL_OBJECT *ob, long data);
};


///
class InsetPrintIndex: public InsetCommand {
public:
	///
	InsetPrintIndex();
	///
	InsetPrintIndex(Buffer*);
	///
	~InsetPrintIndex();
	/// Updates needed features for this inset.
	void Validate(LaTeXFeatures &features) const;
	///
	void Edit(int, int, unsigned int, BufferView *) {}
	///
	Inset::EDIT Editable() const{
		return Inset::EDITABLE;
	}
	///
	bool display() const { return true; }
	///
	Inset::Code LyxCode() const;
	///
	string getScreenLabel() const;
private:
	///
	Buffer *owner;
};
#endif
