// -*- C++ -*-
/* This file is part of*
 * ======================================================
 *
 *           LyX, The Document Processor
 * 	 
 *	    Copyright (C) 1995 Matthias Ettrich
 *
 *======================================================*/

#ifndef _INSET_INFO_H
#define _INSET_INFO_H

#ifdef __GNUG__
#pragma interface
#endif

#include "lyxinset.h"
#include "lsignal.h"
#include "LString.h"


/** Info. Handles the note insets.
  
  This class handles the note insets. The edit operation bringes up
  a dialog, where the user can type a note about life or something
  else of interest. When collapsed, the inset is displayed as "Note"
  in a yellow box. Currently, the Read-function is a terrible hack. 
  Some day in the distant future, this will hopefully be obsoleted by 
  a true comment-environment. */
class InsetInfo: public Inset {
public:
	///
	InsetInfo();
	///
	InsetInfo(string const & string);
	///
	~InsetInfo();

	///
	int ascent(Painter &, LyXFont const &) const;
	///
	int descent(Painter &, LyXFont const &) const;
	///
	int width(Painter &, LyXFont const &) const;
	///
	void draw(Painter &, LyXFont const &, int baseline, float &x);

	///
	string const & getContents() const;
	///
	void setContents(string const &);
	///
	void Write(FILE *file);
	///
	void Read(LyXLex &lex);
	///
	int Latex(FILE *file, signed char fragile);
	///
	int Latex(string &file, signed char fragile);
	/// what appears in the minibuffer when opening
	string EditMessage() const {return "Opened note";}
	///
	void Edit(int, int, unsigned int, BufferView *);
	///
	Inset::EDIT Editable() const;
	///
	Inset::Code LyxCode() const;
	///
	Inset* Clone();
	///
	Signal0 gone;
private:
	///
	string contents;
};

#endif
