// -*- C++ -*-
/* This file is part of
 * ======================================================
 * 
 *           LyX, The Document Processor
 *           Copyright (C) 1995 Matthias Ettrich
 *           Copyright (C) 1995-1998 The LyX Team.
 *
 *           This file is Copyright (C) 1996-1998
 *           Lars Gullik Bj<F8>nnes
 *
 * ======================================================
 */

#ifndef INSETNOTE_H
#define INSETNOTE_H

#ifdef __GNUG__
#pragma interface
#endif

#include "lyxinset.h"

class LyXParagraph;

///
class InsetNote : public UpdatableInset {
public:
	///
	InsetNote(Buffer*);
	///
	virtual ~InsetNote();
	///
	int ascent(Painter &, LyXFont const &) const;
	///
	int descent(Painter &, LyXFont const &) const;
	///
	int width(Painter &, LyXFont const &) const;
	///
	void draw(Painter &, const LyXFont &, int, float &x);
	///
	string EditMessage() const;
	///
	Inset::EDIT Editable() const;
	///
	void Write(FILE *file);
	///
	void Read(LyXLex &);
	///
	int Latex(FILE *file, signed char fragile);
	///
	int Latex(string & file, signed char fragile);
	///
	void Validate(LaTeXFeatures &featurs) const;
	///
	Inset::Code LyxCode() const;
	///
	InsetNote* Clone();
	///
	bool display() const;
	///
	LyXFont GetFont(LyXParagraph* par, int pos);
	///
	int BeginningOfMainBody(LyXParagraph *par);
protected:	
private:
	///
	Buffer *buffer;
	///
	LyXParagraph *par;
};
#endif

