// -*- C++ -*-
/* This file is part of
 * ======================================================
 * 
 *           LyX, The Document Processor
 *
 *	     Copyright (C) 1995 Matthias Ettrich
 *           Copyright (C) 1995-1998 The LyX Team.
 *
 *           This file is Copyright (C) 1996-1998
 *           Lars Gullik Bjnnes
 *
 *======================================================
 */

#ifndef LOCALWORDS_H
#define LOCALWORDS_H

#ifdef __GNUG__
#pragma interface
#endif

#include <set>
#include "LString.h"

/** This class stores the words local to the buffer/document that should
  not be spell checked. The spellchecker should consult this object to
  see if it should spellcheck the word or not.

  Features that can/should be added:
           - view complete list.
	   - be able to edit list.
	   - possible to set "options" on words. (all caps, capitalize, lower)
  */
class LocalWords {
public:
	///
	LocalWords() { }
	///
	LocalWords(const LocalWords &);
	///
	~LocalWords() { }
	///
	LocalWords & operator=(const LocalWords &);
	/// Returns true if thelist is empty.
	bool empty() const;
	/// Returns true if the word is in the list.
	bool exist(LString const &) const;
	/// Addes a word to the LocalWords list.
	void insert(LString const &);
	/// Writes the list to file.
	void write(FILE *file) const;
	/// Reads the list.
	void read(LyXLex &lex);
private:
	///
	typedef set<LString, less<LString> > WordList;
	///
	WordList wordlist;
};

#endif
