// -*- C++ -*-

// A wrapper header file around the singal header files from
// gtk--

// I have not changed the function names so if someone want to write
// a gtk port, the signals we use should not be changed.
// One exception, I have a typedef for gtk_signal_base, but this will
// be effective when using gtk too, so still no changes.

// Very short tutorial:
// If you have a class whose methods shall be connected to a signal,
// you must subclass SignalBase.
//
// Three (mainly) functions you use to connect with:
// connect_to_function(...)
// connect_to_method(...)
// connect_to_signal(...)
//
// Declearing signals:
// Signal0 zero;
// Signal1<int> one;
// Signal2<string, int> two;
//
// Throw a signal:
// zero();
// one(1);
// two("Ha!", 9);
//
// there are a few more things you can do with signals: callback value,
// get a connection object, disconnect signals.
//
// Read the gtk-- documentation.
//
// I have checked it with gcc 2.7.2 and egcs 1.0.1, seems to work ok.
//
//   Lgb

#ifndef LSIGNAL_H
#define LSIGNAL_H

#include <config.h>

#ifdef HAVE_MUTABLE
#define GTKMM_CXX_HAVE_MUTABLE 1
#endif

#ifdef COMPILING_FOR_GTKMM
// How to ensure then that we use the "gtk--sig.h" that is supplied with
// gtk--, and not the one supplied with LyX? Easy solution is to give them
// different names, an other solution might be to do -I... tricks, and
// keep theses kind of header files in special directories.
  #include "gtk--sig.h"
#else
  #define GTKMM_SIGNALS_WITHOUT_GTK
  #include "gtk--sig.h"
  #undef GTKMM_SIGNALS_WITHOUT_GTK
#endif

typedef Gtk_Signal_Base SignalBase;
#endif
