// -*- C++ -*-
/* This file is part of
 * ======================================================
 * 
 *           LyX, The Document Processor
 * 	 
 *	    Copyright (C) 1995 Matthias Ettrich
 *          Copyright (C) 1995-1998 The LyX Team.
 *
 *======================================================*/

#ifndef PARAPARAMS_H
#define PARAPARAMS_H

#ifdef __GNUG__
#pragma interface
#endif

#include "vspace.h"

class BufferParams;
class LyXLex;

class LyXParagraphParameters {
public:
	///
	LyXParagraphParameters();
	///
	LyXParagraphParameters(const LyXParagraphParameters &);
	///
	~LyXParagraphParameters() { }
	///
	LyXParagraphParameters & operator=(const LyXParagraphParameters &);
	///
	bool operator==(const LyXParagraphParameters &) const;
	///
	void init();
	///
	void read(LyXLex &lex);
	///
	void writeFile(FILE *, BufferParams &,
		       char footflag, char dth) const;

	///
	VSpace added_space_top;
	VSpace added_space_bottom;
	bool line_top;
	bool line_bottom;
	bool pagebreak_top;
	bool pagebreak_bottom;
	char align;
	bool noindent;
};
#endif
