
#include <config.h>

#ifdef __GNUG__
#pragma implementation
#endif

#include "insetbibtex.h"
#include "LyXView.h"
#include "gettext.h"
#include "lstrings.h"


InsetBibtex::InsetBibtex(string const & dbase, string const & style,
			 Buffer *o)
	:InsetCommand("BibTeX", dbase, style), owner(o)
{
}


InsetBibtex::~InsetBibtex()
{
	gone();
}


string InsetBibtex::getScreenLabel() const
{
	return _("BibTeX Generated References");
}


int InsetBibtex::Latex(FILE *file, signed char /*fragile*/)
{
	string bib;
	signed char dummy = 0;
	int result = Latex(bib, dummy);
	fprintf(file, "%s", bib.c_str());
	return result;
}


int InsetBibtex::Latex(string &file, signed char /*fragile*/)
{
	file += "\\bibliographystyle{";
	file += getOptions();
	file += "}\n";
	file += "\\bibliography{";
	file += getContents();
	file += "}\n";
	return 2;
}


// BibTeX should have its own dialog. This is provisional.
void InsetBibtex::Edit(int, int, unsigned int, BufferView *bv)
{
	bv->getOwner()->getPopups().showFormBibtex(this);
}


bool InsetBibtex::addDatabase(string const &db)
{
	if (!contains(contents, db.c_str())) {
		if (!contents.empty()) 
			contents += ',';
		contents += db;
		return true;
	}
	return false;
}


bool InsetBibtex::delDatabase(string const &db)
{
	if (contains(contents, db.c_str())) {
		string bd = db;
		int n = tokenPos(contents, ',', bd);
		if (n > 0) {
			string tmp(",");
			tmp += bd;
			contents = subst(contents, tmp.c_str(), ",");
		} else if (n==0)
			contents = split(contents, bd, ',');
		else 
			return false;
	}
	return true;
}
