#include <config.h>

#include <stdlib.h>

#ifdef __GNUG__
#pragma implementation
#endif

#include "insetindex.h"
#include "buffer.h"
#include "debug.h"
#include "LaTeXFeatures.h"
#include "gettext.h"
#include "LString.h"
#include "LyXView.h"


InsetIndex::InsetIndex(string const & key)
	: InsetCommand("index", key) 
{}


InsetIndex::~InsetIndex()
{
	gone();
}


void InsetIndex::Edit(int, int, unsigned int, BufferView *bv)
{
	bv->getOwner()->getPopups().showFormIndex(this);
}


string InsetIndex::getScreenLabel() const
{
	string tmp;
	tmp = _("Index: ");
	tmp+=getContents();
	return tmp;
}


//
// InsetPrintIndex
//

InsetPrintIndex::InsetPrintIndex()
	: InsetCommand("printindex")
{
	owner = 0;
}


InsetPrintIndex::InsetPrintIndex(Buffer *o)
	: InsetCommand("printindex"), owner(o)
{
}


InsetPrintIndex::~InsetPrintIndex()
{
}


string InsetPrintIndex::getScreenLabel() const
{
	return _("PrintIndex");
}


void InsetPrintIndex::Validate(LaTeXFeatures &features) const
{
	features.makeidx = true;
}


Inset::Code InsetPrintIndex::LyxCode() const
{
 	return Inset::INDEX_CODE;
}
