/* This file is part of
 * ======================================================
 * 
 *           LyX, The Document Processor
 * 	 
 *          Copyright (C) 1998 The LyX Team.
 *
 *======================================================*/

#include <config.h>

#ifdef __GNUG__
#pragma implementation
#endif

#include "insetmargin.h"
#include "gettext.h"
#include "lyxfont.h"
#include "BufferView.h"
#include "lyxscreen.h"
#include "painter.h"
#include "lyx_gui_misc.h"


InsetMargin::InsetMargin(Buffer *bf): InsetCollapsable(bf)
{
    setLabel("margin");
    LyXFont font(LyXFont::ALL_SANE);
    font.decSize();
    font.decSize();
    font.setColor(LColor::footnote);
    setFont(font);
    setAutoCollapse(false);
}


Inset* InsetMargin::Clone()
{
    InsetMargin *result = new InsetMargin(buffer);
    return result;
}


string InsetMargin::EditMessage() const
{
    return _("Opened Marginal note Inset");
}


void InsetMargin::Write(FILE *file)
{
    fprintf(file, "\\begin_inset Margin\n");
    WriteParagraphData(file);
    fprintf(file, "\\end_inset\n");
}


bool InsetMargin::InsertInset(Inset *inset)
{
    if ((inset->LyxCode() == Inset::FOOT_CODE) ||
	(inset->LyxCode() == Inset::MARGIN_CODE)) {
	return false;
    }
    return InsetText::InsertInset(inset);
}


int InsetMargin::Latex(FILE *file, signed char ch)
{
    string l;
    int i = Latex(l, ch);
    fprintf(file, "%s", l.c_str());
    return i;
}


int InsetMargin::Latex(string &latex, signed char ch)
{
    int i;
    latex += "\\marginpar{";
    i = InsetText::Latex(latex, ch);
    latex += "}";

    return i;
}
