/* This file is part of*
 * ======================================================
 *
 *           LyX, The Document Processor
 * 	 
 *	    Copyright (C) 1997-1998 LyX Team
 * 
 *======================================================*/


// Created by asierra 970813

#include <config.h>


#ifdef __GNUG__
#pragma implementation
#endif

#include "insetparent.h"
#include "filetools.h"
#include "BufferView.h"
#include "LyXView.h"
#include "lyxfunc.h"
#include "commandtags.h"
#include "buffer.h"

InsetParent::InsetParent(string fn, Buffer* owner): InsetCommand("lyxparent")
{
    if (owner)
	setContents(MakeAbsPath(fn, OnlyPath(owner->getFileName())));
    else
	setContents(fn);
}

void InsetParent::Edit(int, int, unsigned int, BufferView *bv)
{    
    bv->getOwner()->getLyXFunc().Dispatch(LFUN_CHILDOPEN, 
						     getContents().c_str());
}

// LaTeX must just ignore this command
int InsetParent::Latex(FILE *file, signed char fragile)
{
    fprintf(file, "%%#{lyx}");
    InsetCommand::Latex(file, fragile);
    return 0;
}

// LaTeX must just ignore this command
int InsetParent::Latex(string &file, signed char fragile)
{
    file += "%%#{lyx}";
    InsetCommand::Latex(file, fragile);
    return 0;
}
