// -*- C++ -*-
/* This file is part of*
 * ======================================================
 *
 *           LyX, The Document Word Processor
 * 	 
 *	    Copyright (C) 1995 Matthias Ettrich
 *          Copyright (C) 1996-1998 The LyX Team.
 * 
 *======================================================*/

#ifndef INSET_TOC_H
#define INSET_TOC_H

#ifdef __GNUG__
#pragma interface
#endif

#include "insetcommand.h"

// Created by Lgb 970527

/** Used to insert table of contents
 */
class InsetTOC: public InsetCommand {
public:
	///
	InsetTOC(): InsetCommand("tableofcontents") { }
	///
	InsetTOC(Buffer *b): InsetCommand("tableofcontents"),owner(b){};
        ///
        Inset* Clone() { return new InsetTOC(owner); }
    	///
	string getScreenLabel() const;
        
	/// On edit, we open the TOC pop-up
	void Edit(int, int, unsigned int, BufferView *);

        ///
        Inset::EDIT Editable() const {
		return Inset::EDITABLE; // not yet
	}
	///
	bool display() const { return true; }
	///
	Inset::Code LyxCode() const { return Inset::TOC_CODE; }
private:
	///
	Buffer *owner;
};
#endif
