/* This file is part of
 * ======================================================
 * 
 *           LyX, The Document Processor
 *
 *	     Copyright (C) 1995 Matthias Ettrich
 *           Copyright (C) 1995-1998 The LyX Team.
 *
 *           This file is Copyright (C) 1996-1998
 *           Lars Gullik Bjnnes
 *
 *======================================================
 */

#include <config.h>

#ifdef __GNUG__
#pragma implementation
#endif

#include "localwords.h"
#include "lyxlex.h"


LocalWords::LocalWords(const LocalWords &lw)
{
	wordlist = lw.wordlist;
}

LocalWords & LocalWords::operator=(const LocalWords &lw)
{
	wordlist = lw.wordlist;
	return *this;
}


bool LocalWords::empty() const
{
	return wordlist.empty();
}


bool LocalWords::exist(LString const &w) const
{
	WordList::const_iterator wci = wordlist.find(w);
	return wci != wordlist.end();
}


void LocalWords::insert(LString const &w)
{
	wordlist.push_back(w);
}

void LocalWords::write(FILE *file) const
{
	fprintf(file, "\\begin_localwords");
	WordList::const_iterator wci = wordlist.begin();
	for(; wci != wordlist.end(); ++wci) {
		fprintf(file, "%s\n", (*wci));
	}
	fprintf(file, "\\end_localwords");
}


void LocalWords::read(LyXLex &lex)
{
	lex.nextToken();
	LString str = lex.GetString();
	while( str != "\\end_localwords" && lex.IsOK()) {
		wordlist.push_back(str);
		lex.nextToken();
		str = lex.GetString();
	}
}
