/*
 * A n t l r  T r a n s l a t i o n  H e a d e r
 *
 * Terence Parr, Will Cohen, and Hank Dietz: 1989-1998
 * Purdue University Electrical Engineering
 * With AHPCRC, University of Minnesota
 * ANTLR Version 1.33MR10
 *
 *   /home/ale/bin/antlr -CC -e3 lyx3.g
 *
 */
#include <stdio.h>
#define ANTLR_VERSION	133MR10
#include "tokens.h"

#include "AToken.h"
#include "ATokPtr.h"
#include "LString.h"

typedef ANTLRCommonToken ANTLRToken;
#include "AParser.h"
#include "LyXParser.h"
#include "DLexerBase.h"
#include "ATokPtr.h"
#ifndef PURIFY
#define PURIFY(r,s) memset((char *) &(r),'\0',(s));
#endif

#include "PBlackBox.h"
#include "DLGLexer.h"

int main() {
	
    ParserBlackBox<DLGLexer, LyXParser, ANTLRToken> p(stdin);
	p.parser()->prog();
	return 0;
}

void
LyXParser::prog(void)
{
	zzRULE;
	ANTLRTokenPtr opts;   
	body();
	fprintf(stderr, "Done!\n");  
	return;
fail:
	syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
	resynch(setwd1, 0x1);
}

void
LyXParser::body(void)
{
	zzRULE;
	{
		while ( 1 ) {
			if ( !((setwd1[LA(1)]&0x2))) break;
			if ( (setwd1[LA(1)]&0x4) ) {
				atom();
			}
			else {
				if ( (LA(1)==Command) ) {
					command();
				}
				else {
					if ( (LA(1)==LyxCommand) ) {
						lyxcommand();
					}
					else {
						if ( (setwd1[LA(1)]&0x8) ) {
							argument();
						}
						else {
							if ( (LA(1)==BeginEnv) ) {
								environ();
							}
							else break; /* MR6 code for exiting loop "for sure" */
						}
					}
				}
			}
		}
	}
	return;
fail:
	syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
	resynch(setwd1, 0x10);
}

void
LyXParser::atom(void)
{
	zzRULE;
	if ( (LA(1)==Character) ) {
		zzmatch(Character);
		
		emit("word", LT(1)->getText());  
 consume();
	}
	else {
		if ( (LA(1)==Accent) ) {
			zzmatch(Accent);
			
			emit("accent", LT(1)->getText());  
 consume();
		}
		else {
			if ( (LA(1)==Iso8859) ) {
				zzmatch(Iso8859);
				
				emit("iso-8859-x", LT(1)->getText());  
 consume();
			}
			else {
				if ( (LA(1)==Word) ) {
					zzmatch(Word);
					
					emit("Word", LT(1)->getText());  
 consume();
				}
				else {
					if ( (LA(1)==WordSep) ) {
						zzmatch(WordSep);
						
						emit("Space", "");  
 consume();
					}
					else {
						if ( (LA(1)==ParSep) ) {
							zzmatch(ParSep);
							
							emit("ParSep","");  
 consume();
						}
						else {
							if ( (LA(1)==Number) ) {
								zzmatch(Number);
								
								emit("Number", LT(1)->getText());  
 consume();
							}
							else {
								if ( (LA(1)==Punctuation) ) {
									zzmatch(Punctuation);
									
									emit("Punctuation", LT(1)->getText());  
 consume();
								}
								else {
									if ( (LA(1)==Special) ) {
										zzmatch(Special);
										
										emit("Special", LT(1)->getText());  
 consume();
									}
									else {
										if ( (LA(1)==String) ) {
											zzmatch(String);
											
											emit("String", LT(1)->getText());  
 consume();
										}
										else {
											if ( (LA(1)==Tab) ) {
												zzmatch(Tab);
												
												emit("Tabulator", LT(1)->getText());  
 consume();
											}
											else {FAIL(1,err1,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
	return;
fail:
	syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
	resynch(setwd1, 0x20);
}

void
LyXParser::command(void)
{
	zzRULE;
	zzmatch(Command);
	
	emit("Command",  &LT(1)->getText()[1]);  
 consume();
	return;
fail:
	syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
	resynch(setwd1, 0x40);
}

void
LyXParser::argument(void)
{
	zzRULE;
	if ( (LA(1)==CurlyBegin) ) {
		zzmatch(CurlyBegin);
		
		
		emit("Open argument", "");
 consume();
		body();
		zzmatch(CurlyEnd);
		
		
		emit("Close argument", "");
 consume();
	}
	else {
		if ( (LA(1)==SharpBegin) ) {
			zzmatch(SharpBegin);
			
			
			emit("Open optional argument", "");
 consume();
			body();
			zzmatch(SharpEnd);
			
			
			emit("Close optional argument", "");
 consume();
		}
		else {FAIL(1,err2,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
	}
	return;
fail:
	syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
	resynch(setwd1, 0x80);
}

void
LyXParser::string_argument(void)
{
	zzRULE;
	if ( (LA(1)==CurlyBegin) ) {
		zzmatch(CurlyBegin);
		
		
		emit("Open argument", "");
 consume();
		body();
		zzmatch(CurlyEnd);
		
		
		emit("Close argument", "");
 consume();
	}
	else {
		if ( (LA(1)==SharpBegin) ) {
			zzmatch(SharpBegin);
			
			
			emit("Open optional argument", "");
 consume();
			body();
			zzmatch(SharpEnd);
			
			
			emit("Close optional argument", "");
 consume();
		}
		else {FAIL(1,err3,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
	}
	return;
fail:
	syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
	resynch(setwd2, 0x1);
}

void
LyXParser::environ(void)
{
	zzRULE;
	zzmatch(BeginEnv);
	 consume();
	zzmatch(Argument);
	
	
	emit("Begin",LT(1)->getText());
 consume();
	body();
	zzmatch(EndEnv);
	 consume();
	zzmatch(Argument);
	
	
	emit("End", LT(1)->getText());
 consume();
	return;
fail:
	syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
	resynch(setwd2, 0x2);
}

void
LyXParser::lyxcommand(void)
{
	zzRULE;
	ANTLRTokenPtr cmd=NULL;
	zzmatch(LyxCommand);
	
	cmd = (ANTLRTokenPtr)LT(1);

	emit("LyXCommand", &cmd->getText()[6]);  
 consume();
	return;
fail:
	syn(zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk);
	resynch(setwd2, 0x4);
}
