// Intended to be a process manager, keep controll over which processes
// has been started in a non-blocking manner (fork, exec)
// and what to do when they return.

/*
  This is kindo how I'd like this to work:

  The class have controll of all the pids we are currently waiting for
  what to do when we gets it.

  The class will also know if the pid returned from wait is expected or not.

  This could be the interface to the class:
  
  pid_connect(pid, <func>);

  connects a pid to a function that should be run when that process returns.

  will this always be able to get the pid? Or might this turn zombies on us?

  */

#include <config.h>
#include <stdio.h>
#include "procMgr.h"
#include "debug.h"
#include "LString.h"
#include "lstrings.h"

// from spellchecker.C
extern void sigchldhandler(int sig);

ProcessManager procMgr;


void ProcessManager::procMgr_sa_handler(int) {
	procMgr.handleChildDeath();
}


ProcessManager::ProcessManager() {
	pw = 0;
	// This is what I want:
	//act.sa_handler = procMgr_sa_handler;
	// this is what I use for now:
	act.sa_handler = sigchldhandler;
	//act.sa_mask = 0;
	act.sa_flags = 0;
	sigaction(SIGCHLD, &act, 0);
};


void ProcessManager::handleChildDeath()
{
	lyxerr << "Child sig caught!\n";
}



void ProcessManager::addpidwait(int pid)
{
	// adds pid to pid wait list
	register pidwait *p = new pidwait;

	p->pid = pid;
	p->next = pw;
	pw = p;

	if (lyxerr.debugging()) {
		lyxerr << "Pids to wait for: \n" << p->pid << '\n';
		while (p->next) {
			p = p->next;
			lyxerr << p->pid << '\n';
		}
	}
}




