/* This file is part of
 * ======================================================
 * 
 *           LyX, The Document Processor
 * 	 
 *          Copyright (C) 1995-1999 The LyX Team.
 *
 * ======================================================*/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#ifdef __GNUG__
#pragma implementation
#endif

#include "Regexp.h"

Regexp::Regexp()
	: preg(0), pmatch(0), compiled(false)
{}


Regexp::Regexp(string regex)
	: preg(0), pmatch(0), regex_(regex), compiled(false)
{}


Regexp::~Regexp()
{
	if (preg) {
		regfree(preg);
		delete preg;
	}
	if (pmatch) delete[] pmatch;
}


void Regexp::setRegex(string regex)
{
	compiled = false;
	regex_ = regex;
	if (preg) {
		regfree(preg);
		delete preg;
	}
	if (pmatch) delete[] pmatch;
}


Regexp::interval Regexp::exec(string str) {
	if (!compiled) {
		preg = new regex_t;
		int a = regcomp(preg, regex_.c_str(), REG_ICASE);
		if (a != 0)
			return interval(string::npos, a);
	}
	
	pmatch = new regmatch_t[1];
	int b = regexec(preg, str.c_str(), 1, pmatch, 0);
	if (b == 0) {
		return interval(pmatch->rm_so, pmatch->rm_eo);
	} else {
		return interval(string::npos, 0);
	}
}
