
#include <config.h>

#include "timer.h"

struct Timer::priv_timer_impl {
	priv_timer_impl(Timer *own)
		: owner(own)
	{
		timer = fl_add_timer(FL_HIDDEN_TIMER, 0,0,0,0,"Timer");
		fl_set_object_callback(timer, timer_cb, 0);
		timer->u_vdata = owner;
	}
	~priv_timer_impl()
	{
		if (timer)
			fl_free_object(timer);
	}
	FL_OBJECT * timer;
	static void timer_cb(FL_OBJECT *ob, long)
	{
		Timer *timer = static_cast<Timer*>(ob->u_vdata);
		timer->bell();
	}
	Timer *owner;
};


Timer::Timer()
{
	impl = new priv_timer_impl(this);
}


Timer::~Timer()
{
	delete impl;
}


void Timer::set(float f)
{
	fl_set_timer(impl->timer, f);
}


void Timer::stop()
{
	fl_set_timer(impl->timer, 0.0);
}
